<?php
//************************************************************************************
//** config.inc.php - configuration file
//** This file contains the configuration file written by Evgen Leontev (c) 2005 and 
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

/* GENERAL */
$conf['db_host']    = "localhost";
$conf['db_base']    = "jmp";
$conf['db_user']    = "root";
$conf['db_pass']    = "";
$conf['db_driver']  = "mysql";             // no other were tested 
$conf['tbl_pref']   = 's_'; 				    
  
$conf['session_name'] = 'gdfrtsvfdr'; 	   // session name for admin area
$conf['lang']         = 'en';              // see admin/lang/ - for available languages
                                           // or check on http://sourceforge.net/projects/jumper


/* PATHS */
// if you need write this manually, may required on windows or for cron jobs
//$_SERVER['DOCUMENT_ROOT'] = 'c:/Inetpub/wwwroot';
//$_SERVER['HTTP_HOST']     = 'domain.com'

// admin path
$conf['home_dir']         = '/jmp/admin/';     // path to admin dir without DOCUMENT_ROOT

// client path
$conf['client_home_dir']  = '/jmp/';           // path to jmp dir without DOCUMENT_ROOT
$conf['fck_upload_dir']	  = '/jmp_upload/';    // where FCK editor place uploaded images (relative to DOCUMENT_ROOT)

// extra path
$conf['extra_home_dir']   = '/jmp_extra/';


/* OTHERS */  				     	 // some configs 1 = yes, 0 = no
$conf['debug_info']       = 0;		 // display $_GET, $_SESSION, $_POST and also set displaying all errors
$conf['debug_speed']      = 0;		 // display page generating speed
$conf['debug_db']         = 0;		 // display all sent sql (adodb format)
$conf['demo_mode']        = 0;       //


$conf['app_width']        = '980';   // main box width you can use  % (in admin).
$conf['auth_check_ip']    = 0;		 // on every request ip will be checked with saved one on login
$conf['auth_expired']     = 60;	     // time in minutes after that if no activity authentication will be deleted (in admin)
$conf['use_https']        = 0;		 // not tested										
$conf['limit']            = 10;		 // default records per page (in admin)
$conf['limit_range']      = array(10, 20, 40);  // default limit range per page (in admin)


$conf['use_mod_rewrite']  = 0;  // this force client side to use "Search engine friendly URL" 
                              	// it should work automatically but if does not try set it to 1
								
								
/* IN MOST CASES THERE IS NO NEED TO EDIT ANYTHING BELOW THIS LINE */
/* --------------------------------------------------------------- */
								
/* PATHS */
// admin path
$conf['root_dir']         = $_SERVER['DOCUMENT_ROOT'] . $conf['home_dir'];
$conf['home_path']        = 'http://' . $_SERVER['HTTP_HOST'] . $conf['home_dir'];

// client path
$conf['client_root_dir']  = $_SERVER['DOCUMENT_ROOT'] . $conf['client_home_dir'];
$conf['client_home_path'] = 'http://' . $_SERVER['HTTP_HOST'] . $conf['client_home_dir'];
$conf['site_address']     = $_SERVER['HTTP_HOST'];

// extra path
$conf['extra_root_dir']   = $_SERVER['DOCUMENT_ROOT'] . $conf['extra_home_dir'];
$conf['php_path']         = '/usr/local/bin/php'; // probably could be required in cron job for example								
								
														
$win = (substr(PHP_OS, 0, 3) == "WIN");
$include_separator = ($win) ? ';' : ':';
$include_path = array();
 

/* PRODUCT INFORMATION */
$conf['product_name'] = 'Jumper Networks';
$conf['product_www']  = 'http://www.jumpernetworks.com/';
$conf['product_version'] = 'Jumper 2.0.1.4';
$conf['home_path'] = ($conf['use_https']) ? str_replace('http', 'https', $conf['home_path']) : $conf['home_path'];

// in some cases we have double slash
$conf['root_dir'] = str_replace('//', '/', $conf['root_dir']);
$conf['client_root_dir'] = str_replace('//', '/', $conf['client_root_dir']);
$conf['extra_root_dir'] = str_replace('//', '/', $conf['extra_root_dir']);


define('APP_ROOT_DIR', 		$conf['root_dir']);
define('APP_HOME_PATH', 	$conf['home_path']);

define('APP_CLIENT_DIR', 	$conf['client_root_dir']);
define('APP_CLIENT_PATH', 	$conf['client_home_path']);
define('APP_SITE_ADDRESS',	$conf['site_address']);

define('APP_LIB_DIR',       	$conf['root_dir'] . 'lib/');
define('APP_MODULE_DIR',    	$conf['root_dir'] . 'modules/');
define('APP_TMPL_DIR', 		$conf['root_dir'] . 'template/');
define('APP_EMAI_TMPL_DIR', 	$conf['root_dir'] . 'template_email/');
define('APP_CACHE_DIR', 	$conf['root_dir'] . 'cache/');

define('APP_LANG', 		$conf['lang']);
define('APP_MSG_DIR', 		$conf['root_dir'] . 'lang/');
define('APP_MSG_LANG_DIR', 	$conf['root_dir'] . 'lang/'.$conf['lang'].'/');

define('APP_DEMO_MODE', 	$conf['demo_mode']);

define('APP_EXTRA_MODULE_DIR',  $conf['extra_root_dir']);



$include_path[] = ini_get('include_path');
$include_path[] = APP_LIB_DIR;
$include_path[] = APP_LIB_DIR . 'Pear';

ini_set('include_path', implode($include_separator, $include_path));
ini_set('display_errors', 1);
//ini_set('arg_separator.output', '&amp;');

if($conf['debug_info']) {
	ini_set('error_reporting', E_ALL);
} else {
	//ini_set('display_errors', 0);
	ini_set('error_reporting', E_ALL ^ E_NOTICE);
	//ini_set('error_reporting', E_ALL ^ (E_NOTICE | E_WARNING)); 
	//ini_set('error_reporting', E_ALL ^ (E_ERROR | E_WARNING | E_PARSE | E_NOTICE)); 
}
?>