<?php
//************************************************************************************
//** background_send.php - Cron Background Send File
//** This file defines the cron background send commands modified by Steve Perry 
//** (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

$path = str_replace('cron/notify_admin_user', '', str_replace('\\', '/', getcwd()));

require_once $path . 'config.inc.php';
require_once APP_ROOT_DIR . 'cron/common_cron.php';
require_once APP_ROOT_DIR . 'cron/notify_admin_user/Sender.php';

//if($_SERVER['argv'][1] != 'run') { return; }

$sender = &new Sender();
$last_sent = $sender->readLastRun();
$categories = $sender->getCategories();


$num_sent = 0;
$result = &$sender->getProfiles($last_sent);
while($row = $result->FetchRow()) {
	
	$parent_categories = $sender->getParentCategories($row['category_id'], $categories);	
	$subscribers = $sender->getSubscribers(implode(',', $parent_categories));
	
	//echo "<pre>"; print_r($row['id']); echo "</pre>";
	//echo "<pre>"; print_r($parent_categories); echo "</pre>";
	//echo "<pre>"; print_r($subscribers); echo "</pre>";
	
	foreach($subscribers as $k => $v) {
		$sent = $sender->send($sender->getLetter($row, $v), $v);
		if($sent) {
			$num_sent++;
		}
		
		$sender->sleep();	
	}
}

if($num_sent) {
	$sender->writeLastRun();
}

$sender->log('Letters sent: ' . $num_sent);
$sender->log('FINISHED');
?>