//************************************************************************************
//** spiner.js - Xajax Spinner for Jumper
//** This library contains the the standard xajax.call() function to show our little 
//** spinner and then carry on as usualmodified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

//Now for the fun overriding part. 

//keep around the old call function
xajax.realCall = xajax.call;
//override the call function to bend to our wicked ways
xajax.call = function(sFunction, aArgs, sRequestType)
{
    //show the spinner
 	if(document.getElementById('spinner')) {
	    this.$('spinner').style.display = 'inline';
	}

    //call the old call function
    return this.realCall(sFunction, aArgs, sRequestType);
}

//So now we've overridden the xajax.call() function so that it shows our spinner when 
//we make an xajax call, we just have to override the xajax.processResponse() function to hide the spinner.

//save the old processResponse function for later
xajax.realProcessResponse = xajax.processResponse;
//override the processResponse function
xajax.processResponse = function(xml)
{
    //hide the spinner
 	if(document.getElementById('spinner')) {
	    this.$('spinner').style.display = 'none';	
	}
	
	
    //call the real processResponse function
    return this.realProcessResponse(xml);
}