<?php
//************************************************************************************
//** AppMailParser.php - Application Mail Parser
//** This file contains the application mail parser written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

require_once 'jumper_lib/Util/Replacer.php';
require_once 'jumper_lib/HTML/tplTemplatez.php';
require_once 'core/app/AppMsg.php';
require_once 'core/app/AppMailModel.php';


class AppMailParser
{

	var $template_dir;
	var $templates = array('send_to_friend'			=> 'jmp_friend.txt',
	                       'answer_to_user'			=> 'jmp_answer.txt',
						   'contact'				=> 'jmp_contact.txt',
						   'confirm_registration'	=> 'confirm_registration.txt',
						   'generated_password'		=> 'generated_password.txt',
						   
						   'admin_generated_password'		=> 'admin_generated_password.txt',
						   //'admin_confirm_registration'	=> 'admin_confirm_registration.txt'
						   );
	
	
	var $vars      = array('support_name', 
		                   'support_email', 
						   'support_mailer',
						   'name',
						   'username',
						   'first_name',
						   'last_name',
						   'midlle_name',
						   'email',
						   'link'
					       );

	
	
	function AppMailParser() {
		$this->template_dir = APP_EMAI_TMPL_DIR;
		$this->setReplaser();
	}

	
	function setReplaser() {
		$this->replacer = &new Replacer;
		$this->replacer->s_var_tag = "[";
		$this->replacer->e_var_tag = "]";
	}
	
	
	function setSettingVars($setting) {
		$this->assign('support_name', $setting['from_name']);
		$this->assign('support_email', $setting['from_email']);
		$this->assign('support_mailer', $setting['from_mailer']);
	}
	
	
	//function setNames($values) {
	//	if(!empty($values['first_name'] && !empty($values['last_name'])) {
	//		$this->assign('name', $values['first_name'] . ' ' . $values['first_name']);
	//	}
	//}
	
	
	function getVars() {
		return $this->vars;
	}
	
	
	function assign($var, $value = false) {
		$this->replacer->assign($var, $value);
	}
	
	
	function parse($str) {
		return $this->replacer->parse($str);
	}
	
	
	function setTemplate($key, $value) {
		$this->templates[$key] = $value;
	}
	
	
	function getTemplateMsg($letter_key = false) {
		return AppMsg::getMsg('template_msg.ini', 'email_setting', $letter_key);
	}
	
	
	function getTemplate($letter_key) {
		
		$msg = $this->getTemplateMsg($letter_key);
		$template = $this->template_dir . $this->templates[$letter_key];
		
		$tpl = &new tplTemplatez($template);
		$tpl->clean_html = false;
		$tpl->tplParse($msg);
		return $tpl->tplPrint(1);
	}
}
?>