<?php
//************************************************************************************
//** PageRenderer.php - Page Renderer
//** This file contains the page renderer written by Evgen Leontev (c) 2005 and 
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class PageRenderer
{

	var $title_delim = ' / ';
	var $template_dir;
	var $template = 'page.html';
	

	var $meta_title;
	var $meta_keyword;
	var $meta_location;
	var $meta_link;
	var $meta_datatype;
	var $meta_charset;
	
	var $vars = array('meta_title' 		=> 'Title',  
					  'meta_keyword' 	=> '',  
					  'meta_location'=> '',  
					  'meta_link'=> '',  
					  'meta_datatype' 	=> '',  
					  'meta_charset' 	=> ''
					   );
	
	
	
    function PageRenderer($engine = 'tpl_templatez') {
        
		$this->view = &$view;
		$this->template_dir = APP_TMPL_DIR;
		
		$this->tpl = &$this->setEngine($engine);
    }
	
	
	function &setEngine($engine) {
		if($engine == 'tpl_templatez') {
			$t = &new PageRenderer_templatez();
			return $t;
		
		} elseif($engine == 'smarty') {
			$t = &new PageRenderer_smarty();
			return $t;
		} 
	}
	
	
	function render() {
		return $this->tpl->render($this->vars, $this->template_dir, $this->template);	
	}	
	
	

/*
	function assign1($var, $value = false) {
		
		if(is_array($var)) {
			foreach($var as $k => $v) {
			//foreach(array_keys($var) as $k) {
				$this->vars[$k] = &$var[$k];
			}
		} else {
			if($value === false) {
				trigger_error($this->error_pref. " Can't assign value for var - <b>".$var."</b>. Missing argument 2 for tplAssign();");
			} else { 
				$this->vars[$var] = &$value; 
			}
		}
	}
*/

	
	
	function assign(&$var, $value = false) {
		
		if($value) {
			$this->vars[$value] = &$var; 
		
		} else {
		
			if(is_array($var)) {
				foreach($var as $k => $v) {
					$this->vars[$k] = &$var[$k];
				}
			} else {
				if($value === false) {
					trigger_error($this->error_pref. " Can't assign value for var - <b>".$var."</b>. Missing argument 2 for tplAssign();");
				} else { 
					$this->vars[$value] = &$var; 
				}
			}			
		}
	}
	
	
	
	function setTemplate($var) {
		$this->template = $var;
	}
	
	
	function display() {
		echo $this->render();
	}
}



class PageRenderer_templatez
{
	
	function render($vars, $template_dir, $template) {
		
		$tpl = &new tplTemplatez($template_dir . $template);
		$tpl->s_var_tag = '{';
		$tpl->tplParse($vars);
		return $tpl->tplPrint(1);		
	}	
}



class PageRenderer_smarty
{
	
	function render($vars, $template_dir, $template) {
		
		$tpl = &new CommonSmarty();
		$tpl->template_dir = $template_dir;
		$tpl->assign($vars);
		return $tpl->fetch($template);
	}	
}

?>