<?php
//************************************************************************************
//** BaseModel.php - Base Model
//** This file contains the base data table model written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class BaseModel extends BaseApp
{
	
	var $tbl_pref_custom;
	var $tbl_pref;	
	var $tables = array();
	var $custom_tables = array();
	var $db;
	var $limit;
	var $tbl;
	
	var $sql_params = '1';   					// will be added to select rows
	var $sql_params_ar = array();
	
	var $sql_params_select = '1';		
	var $sql_params_select_ar = array();
	
	var $sql_params_from = '';   			
	var $sql_params_from_ar = array();
	
	var $sql_params_order = ''; 
	
	
	
	function BaseModel() {

		$reg =& Registry::instance();
		$this->db 		=& $reg->getEntry('db');
		$this->tbl_pref =& $reg->getEntry('tbl_pref');
		$this->limit 	=& $reg->getEntry('limit');
		$this->extra 	=& $reg->getEntry('extra');
				  
		$this->tbl = $this->setTableNames();
	}
	
	
	function setTableNames() {
		$t = array();
		$t1 = $this->_setTableNames($this->tables, $this->tbl_pref, $this->tbl_pref_custom);
		$t2 = $this->_setTableNames($this->custom_tables, $this->tbl_pref);
		
		return (object) array_merge($t1, $t2);
	}
	
	
	function _setTableNames($tables, $tbl_pref = '', $tbl_pref_custom = '') {
		$tbl =  array(); 
		foreach($tables as $k => $v) {
			$t = (!is_int($k)) ? $k : $v;
			$tbl[$t] = $tbl_pref . $tbl_pref_custom . $v;
		}
		
		return $tbl;
	}
	
	
	// set diffrent sql params used when list records
	function setSqlParams($params, $key = null, $empty = false) {
		static $i = 0;
		$key = ($key) ? $key : $i++;
		if($empty) { $this->sql_params_ar = array(); }
		
		$this->sql_params_ar['default'] = 1;
		$this->sql_params_ar[$key] = $params;
		$this->sql_params = implode(' ', $this->sql_params_ar);
	}
	
	
	// set diffrent sql params used when list records
	function setSqlParamsSelect($params, $key = null) {
		static $i = 0;
		$key = ($key) ? $key : $i++;
		
		$this->sql_params_select_ar['default'] = 1;
		$this->sql_params_select_ar[$key] = $params;
		$this->sql_params_select = implode(', ', $this->sql_params_select_ar);
	}
	
	
	// set diffrent sql params used when list records
	function setSqlParamsFrom($params, $key = null) {
		static $i = 0;
		$key = ($key) ? $key : $i++;
		
		//$this->sql_params_from_ar['default'] = '';
		$this->sql_params_from_ar[$key] = $params;
		$this->sql_params_from = implode(', ', $this->sql_params_from_ar);
	}	
	
	
	function setSqlParamsOrder($val) {
		$this->sql_params_order = $val;
	}
	
	
		
	function getValuesArray($data, $id_field = 'id') {
		$ids = array();
		foreach($data as $k => $v) {
			$ids[] = $v[$id_field];
		}
		
		return $ids;
	}
	
	
	function getValuesString($data, $id_field = 'id') {
		return implode(',', $this->getValuesArray($data, $id_field));
	}

	
	function isExtra($module) {
		return (!empty($this->extra[$module]));
	}
}
?>
