<?php
//************************************************************************************
//** Renderer.php - Renderer Function
//** This file contains the renderer function for building page templates written by 
//** Evgen Leontev (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class Renderer
{
	
	
	function Renderer(&$builder) {
		$this->builder =& $builder;
	}
	
	
	function render() {
	
		$tpl = new tplTemplatez($this->builder->template);
		
		$data['menu'] =& $this->builder->getMenu();
		$data['content'] =& $this->builder->getContent('32121321');
		$data['debug_box'] =& $this->builder->getDebugBox(1,1);		
		
		$tpl->tplParse($data);
		return $tpl->tplPrint(1);
	}
	
	
	function display() {
		echo $this->render();
	}
}


// just empty functions
class PageBuilder extends AppController
{

	function getMenu()     { return; }
	function getContent()  { return; }
	function getDebugBox() { return; }

}



class PageBuilderCommon extends PageBuilder
{
	
	var $template = 'common_template.html ';
	
	
	function &getMenu() {
		$nav = new Navigation;
		$nav->setEqualAttrib('GET', $this->query['module'] );
		$nav->setSubEqualAttrib('GET', $this->query['page']); 
		$nav->setTemplate(APP_TMPL_DIR . 'sub_menu.html');
		$nav->setTemplateCustomRule(true);
		$nav->getMenu($this->module);
		
		return $nav->generate();
	}
	
	
	function &getContent($view)  {
		$page = $this->working_dir . 'action.php';
		require_once ($page);
	}
	
	
	function &getDebugBox($debug_info, $debug_speed) { 
		
		if($debug_info) {
			$html = "<pre><b>GET:</b><br>"; print_r($_GET, 1); "</pre>";
			$html .= "<pre><b>SESSION:</b><br>"; print_r($_SESSION, 1); "</pre>";
		}
		
		if($debug_speed) {
			//timeprint("%min %max graf");
		}
	}
}
?>