<?php
//************************************************************************************
//** CommonEntryView.php - Common Entry View
//** This file contains the common entry view for category messages written by 
//** Evgen Leontev (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class CommonEntryView
{	

	// LIST // -----------------------
	
	function &parseCategoryRoles($category_roles, $msg) {	
		foreach($category_roles as $category_id => $data) {
			foreach($data as $k => $v) {
				$category_roles[$category_id][$k] = sprintf('%s (%s)', $v, $msg['category_msg']);
			}
		}
		
		return $category_roles;
	}	
	
	
	function getPrivateMsg($entry_roles, $category_roles) {
		$roles_msg = '';
		
		if($entry_roles && $category_roles) { 
			$roles_msg = ' - ' . implode('<br> - ', array_merge($entry_roles, $category_roles));
		} elseif($entry_roles) {
			$roles_msg = ' - ' . implode('<br> - ', $entry_roles);
		} elseif($category_roles) {
			$roles_msg = ' - ' . implode('<br> - ', $category_roles);
		}
		
		return $roles_msg;
	}
	
	
	function getColorsAndRolesMsg($row, $msg) {
		$data = array();
		
		if($row['private'] && $row['category_private']) { 
			$data['image_color'] = 'blue';
			$data['private1_msg'] =  sprintf('%s - (%s, %s)', $msg['private_msg'], $msg['entry_msg'], $msg['category_msg']); 
		} else { 
			if($row['private']) {
				$data['image_color'] = 'orange';
				$data['private1_msg'] =  sprintf('%s %s', $msg['private_msg'], $msg['entry_msg']); 
			} else {
				$data['image_color'] = 'red';
				$data['private1_msg'] =  sprintf('%s %s', $msg['private_msg'], $msg['category_msg']);
			}
		}
		
		return $data;
	}	



	// FORM // -----------------------

	function ajaxGetCategoryRoles($category_id, $manager) {
		
		$msg = CommonEntryView::getPrivateCategoryMsg($manager, $category_id);

		$objResponse = new xajaxResponse();
		$objResponse->setCharEncoding($this->encoding);
		
		//$objResponse->addAlert($category_id);
		//$objResponse->addAlert($roles);
		
		$objResponse->addAssign("category_info", "innerHTML", $msg);
		$objResponse->addAssign("category_info_1", "innerHTML", $msg);
	
		return $objResponse;	
	}
	
	
	function getPrivateCategoryMsg(&$manager, $category_id) {
		
		$roles = false;
		$msg = '';
		$is_private = $manager->isPrivate($category_id);
		
		if($is_private) {
			$roles = $manager->getMemberRoleById($category_id, true);
			$roles = ($roles) ? implode(', ', $roles[$category_id]) : '';

			$str = '<span style="color:#cc0000;"><b>%s</b></span>';
			$msg = sprintf($str, $this->msg['private_category_msg']);
			
			if($roles) {
				$str = ' - <b>%s:</b> (%s)';
				$msg .= sprintf($str, $this->msg['roles_msg'], $roles);
			} else {
				$msg .= sprintf(' - <b>%s</b>', $this->msg['no_roles_msg']);
			}
		}
		
		return $msg;	
	}		
}
?>