<?php
//************************************************************************************
//** jpcache-config.php - JPCache Configuration File for Jumper
//** This file contains the jpcache config file written by Jean-Pierre Deckers 
//** (c) 2001-2003 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

    /**
     * Some settings are specific for the type of cache you are running, like
     * file- or database.
     *  
     * Define which jpcache-type you want to use (storage and/or system).
     *
     * This allows for system-specific patches & handling, as sometimes
     * 'platform independent' is behaving quite differently.
     */
     
    $JPCACHE_TYPE = "file";
    //$JPCACHE_TYPE = "mysql";
    //$JPCACHE_TYPE = "dbm"; -- Not yet

    // DOH! Strip out this check for performance if you are sure you did set it.
    if (!isset($JPCACHE_TYPE))
    {
        exit("[jpcache-config.php] No JPCACHE_TYPE has been set!");
    }
    
    /**
     * General configuration options. 
     */
    $JPCACHE_TIME         =   900; // Default number of seconds to cache a page
    $JPCACHE_DEBUG        =   0;   // Turn debugging on/off
    $JPCACHE_IGNORE_DOMAIN=   1;   // Ignore domain name in request(single site)
    $JPCACHE_ON           =   1;   // Turn caching on/off
    $JPCACHE_USE_GZIP     =   1;   // Whether or not to use GZIP
    $JPCACHE_POST         =   0;   // Should POST's be cached (default OFF)
    $JPCACHE_GC           =   1;   // Probability % of garbage collection
    $JPCACHE_GZIP_LEVEL   =   9;   // GZIPcompressionlevel to use (1=low,9=high)
    $JPCACHE_CLEANKEYS    =   0;   // Set to 1 to avoid hashing storage-key:
                                   // you can easily see cachefile-origin.



    /**
     * File based caching setting.
     */
    $JPCACHE_DIR          = APP_CACHE_DIR; // Directory where jpcache must store 
                                   // generated files. Please use a dedicated
                                   // directory, and make it writable
    $JPCACHE_FILEPREFIX   = "jpc-";// Prefix used in the filename. This enables
                                   // us to (more accuratly) recognize jpcache-
                                   // files.

    /**
     * DB based caching settings. 
     */
    $JPCACHE_DB_HOST      = "localhost"; // Database Server
    $JPCACHE_DB_DATABASE  = "jpcache";   // Database-name to use
    $JPCACHE_DB_USERNAME  = "sqluser";   // Username 
    $JPCACHE_DB_PASSWORD  = "passwd";    // Password
    $JPCACHE_DB_TABLE     = "CACHEDATA"; // Table that holds the data
    $JPCACHE_OPTIMIZE     = 1;           // If 'OPTIMIZE TABLE' after garbage
                                         // collection is executed. Please check 
                                         // first if this works on your mySQL!
?>