<?php
//************************************************************************************
//** AuthHttp.php - Authentication HTTP Class
//** This file contains the authenticate HTTP function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//************************************************************************************

class AuthHttp
{
	
	var $realm = 'Restricted area';
	var $do_auth = true;
	var $login;
	var $password;
	
	
	function auth() {
		if($this->do_auth === false) { return; }
		
		if (!isset($_SERVER['PHP_AUTH_USER']) ||
			@$_SERVER['PHP_AUTH_USER'] != $this->login || 
			@$_SERVER['PHP_AUTH_PW'] != $this->password) {
			
			$this->getHeader();
		}
	}
	
	
	function quickAuth($login, $password) {
		$a = new HttpAuth;
		$a->login = $login;
		$a->password = $password;
		$a->auth();
	}
	
	
	function unsetAuth() {
		unset($_SERVER['PHP_AUTH_USER']);
		unset($_SERVER['PHP_AUTH_PW']);
	}
	
	
	function getHeader() {
		header("WWW-Authenticate: Basic realm=\"{$this->realm}\"");
		header("HTTP/1.0 401 Unauthorized");
		exit();
	}
}
?>
