<?php
//************************************************************************************
//** Redirect.php - Redirect Class
//** This file contains the redirect data request function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

// example
// $go = new Redirect();
// $go->setLocation('index.php', array('a'=>'15', 'b'=>'15')) {
// $go->go(); // do redirect

//require_once 'jumper_lib/Url/RequestDataUtil.php';

class Redirect 
{
	var $location;
	var $params = array();
	var $defaults = array();
	var $defaults_rewrite = false; // false - all setted params will be added to defaults
	                               // true - all setted params will be ignored
	
	
	function Redirect($page = null, $param = array()) {
		$page = ($page) ? $page : $_SERVER['PHP_SELF'];
		$this->setLocation($page, $param);
	}
	
	function setDefaults($name, $page, $param = array()) {
		$this->defaults[$name] = array('location'=>$page, 'param'=>$param);
	}
	
	function setLocation($page, $param = array()) {
		$this->location = $page;
		$this->setParams($param);
	}
	
	function setParams($param) {
		if($param) {
			$this->params[] = (is_array($param)) ? http_build_query($param) : $param;
		}
	}
	
	function go($param = array()) {
		header("location:" . $this->getLocation($param));
		exit();
	}
	
	function getJs($param = array()) {
		$js = "document.location.href='" . $this->getLocation($param) . "'";
		return $js;
	}
	
	function getLocation($param = array()) {
		if($param && isset($this->defaults[$param])) {
		
			if($this->defaults_rewrite == true) { 
				$this->params = array();// unset all setted params
			} 
			$this->setLocation($this->defaults[$param]['location'], $this->defaults[$param]['param']);					
		
		} elseif($param) {
			$this->setParams($param);
		}
		
		return $this->format($this->location . implode('&', $this->params));
	}
	
	//function parse($param) {
	//	echo "<pre>"; print_r($param); echo "</pre>";
	//	return http_build_query($param);
	//}
	
	function format($str) {
	
		$str = $this->formatPage($str);
		if(strpos($str, '&') !== false) {
			$search[] = '/\?\?/'; $replace[] = '?'; 
			$search[] = '/&&/'; $replace[] = '&'; 
			$search[] = '/\?&/'; $replace[] = '?';
			$str = preg_replace($search, $replace, $str); 
		}
		
		return $str;
	}
	
	function formatPage($str) {
		if(strpos($str, '?') === false) {
			$pattern = '#\.(php|asp|jsp)[^\?]#';
			if(preg_match($pattern, $str, $match)) {
				$str = preg_replace('#'.$match[1].'#', $match[1].'?', $str); 
			}
		}
		
		return $str;
	}
}


//$go = new Redirect();
//$go->setDefaults('deleted', 'some_page.php', array('good_action'=>'deleted'));
//$go->setParams(array('a'=>'1', 'a'=>'1'));
//echo $go->getLocation();
//echo "<pre>"; print_r($go); echo "</pre>";
?>
