<?php
//************************************************************************************
//** RequestData.php - Request Data Class
//** This file contains the request data function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'jumper_lib/URL/RequestDataUtil.php';


class RequestData
{
	
	var $int_keys = array();
	var $skip_keys = array();
	var $html_keys = array();
	var $html_values = array();
	var $wordrap_num = 80;
	
	
	
	// array: key is that we can access it, value is custom real param
	// for example: real $_GET['custom'] = 20; we can access it like $rq->action, 
	// so on page we always can write $rq->action
	// access any var we want just change value for $predefined array for that key
	//var $predefined = array('action'=>'_a');
	var $predefined = array();
	var $vars = array();
	
	var $action; // to have it on page
	
	
	function RequestData(&$var) {
		$this->setVars($var);
	}
	
	function setIntKeys($key) {
		$this->int_keys[] = $key;
	}	
	
	function setSkipKeys($key) {
		$this->skip_keys[] = $key;
	}

	function setHtmlKeys($key) {
		$this->html_keys[$key] = $key;
	}
	
	// the same as setHtmlKeys 
	function setHtmlValues($key) {
		$this->setHtmlKeys($key);
	}
	
	
	function getHtmlValues() {
		
		$arr = array();
		foreach($this->html_keys as $v) {
			$arr[$v] = &$this->vars[$v];
		}

		return $arr;
	}
	
	function &setVars(&$var) {
		
		//if(!checkPHP()) { // check for php 5.2.0
			$this->setVarsPHP4($var);
		//}
		
		$this->vars =& $var;
		$this->toInt();
		
		return $this->vars;
	}
	
	
	// I do not like it at all
	function setVarsPHP4(&$arr) {
		foreach($arr as $k => $v){
			$this->$k =& $arr[$k];
		}
	}
	
	
/*
	function __set($nm, $val) { //print "Setting [$nm] to $val\n<br>"; 
		if(isset($this->predefined[$nm])) {
			$this->vars[$this->predefined[$nm]] = $val; 
		} else {
			$this->vars[$nm] = $val; 
		}
	}
	
	
	function __get($nm) { //print "Getting [$nm]\n<br>"; 
		if(isset($this->predefined[$nm])) {
			$t = $this->vars[$this->predefined[$nm]]; 
		} elseif (isset($this->vars[$nm])) {
			$t = $this->vars[$nm]; 
		}
		
		if($t === false) {
			return $t; 
		} else {
			echo "Undefined property <b>$nm</b>";
			//echo __FILE__ . '(' . __LINE__ . ')' . __METHOD__; 
		}
	} 
*/
	
	 
	function toInt() {
		return RequestDataUtil::toInt($this->vars, $this->int_keys);
	}
	
	// $param true, false (for server check) or real values
	function stripVars($server_check = false) {
		
		$skip = array_merge($this->skip_keys, $this->html_keys);
		$html_values = $this->getHtmlValues();
			
		RequestDataUtil::stripVars($this->vars, $skip, $server_check, $this->wordrap_num);
		RequestDataUtil::stripVarsHtml($html_values, array(), $server_check);
	}
	
	
	// $param true, false (for server check) or real values
	function &stripVarsValues(&$values, $server_check = 'display') {
		$this->vars = &$values;
		$this->stripVars($server_check);
		
		return $this->vars;
	}
}



class FilterRequestData
{

	var $filters = array();
	
	
	function setFilter($func_name) {
		$this->filters[] = $func_name;
	}	
	
	
	
}
?>