<?php
//************************************************************************************
//** Url.php - URL Class
//** This file sets the URL parameters function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

// example
// $go = new Url();
// $go->set('index.php', array('a'=>'15', 'b'=>'15')) {
// $go->go(); // do redirect

//require_once 'jumper_lib/Url/RequestDataUtil.php';

class Url 
{
	var $page;
	var $params = array();
	var $defaults = array();
	var $defaults_rewrite = true; // false - all setted params will be added to defaults
	                               // true - all setted params will be ignored
	
	
	function Url($page = false, $param = array()) {
		$this->set($page, $param);
	}
	
	
	function setDefaults($name, $page, $param = array()) {
		$this->defaults[$name] = array('page'=>$page, 'param'=>$param);
	}
	
	
	function set($page, $param = array()) {
		$this->setPage($page);
		$this->setParams($param);
	}
	
	
	function setParams($param) {
		if($param) {
			$this->params[] = (is_array($param)) ? urldecode(http_build_query($param)) : urldecode($param);
		} //else {
			//$this->params[] = urldecode(http_build_query($_SERVER['QUERY_STRING']));
		//}
	}
	
	
	function setPage($page = false) {
		$this->page = ($page) ? $page : $_SERVER['PHP_SELF'];
	}
	
	
	function getParams() {
		parse_str(implode('&', $this->params), $output);
		return http_build_query($output);
	}
	
	
	// redirect
	function go($param = array()) {
		header("Location:" . $this->get($param));
		exit();
	}
	
	
	function getJs($param = array()) {
		$js = "document.page.href='" . $this->get($param) . "'";
		return $js;
	}
	
	
	//function getLink($param = array()) {
	//	$js = "document.page.href='" . $this->get($param) . "'";
	//	return $js;
	//}
	
	
   /**
	* Set the Url to the URL of the current page; this can be either the full
	* URL (with parameters) or just the basename.
	* @param $completeUrl whether to use the full URL or just the basename
	* @returns void
	***/
    function setCurrent() {
		$this->params = array();
        $this->set($_SERVER['PHP_SELF'], $_SERVER['QUERY_STRING']);
    }
	
	
	function getCurrent() {
        $this->setCurrent();
		return $this->get();
	}
	
	
	function get($param = array()) {
		if($param && isset($this->defaults[$param])) {
		
			if($this->defaults_rewrite == true) { 
				$this->params = array();// unset all setted params
			} 
			$this->set($this->defaults[$param]['page'], $this->defaults[$param]['param']);					
		
		} elseif($param) {
			$this->setParams($param);
		}
		
		return ($this->format($this->page . $this->getParams()));
	}
	
	//function parse($param) {
	//	echo "<pre>"; print_r($param); echo "</pre>";
	//	return http_build_query($param);
	//}
	
	function format($str) {
	
		$str = $this->formatPage($str);
		if(strpos($str, '&') !== false) {
			$search[] = '/\?\?/'; $replace[] = '?'; 
			$search[] = '/&&/'; $replace[] = '&'; 
			$search[] = '/\?&/'; $replace[] = '?';
			$str = preg_replace($search, $replace, $str); 
		}
		
		return $str;
	}
	
	function formatPage($str) {
		if(strpos($str, '?') === false) {
			$pattern = '#\.(php|asp|jsp)[^\?]#';
			if(preg_match($pattern, $str, $match)) {
				$str = preg_replace('#'.$match[1].'#', $match[1].'?', $str); 
			}
		}
		
		return $str;
	}
}


/*
$func = array('http_build_query');
require_once 'jumper_lib/PHP/Compat.php';
PHP_Compat::loadFunction($func);



$url = new Url();
$url->setDefaults('deleted', 'some_page.php', array('good_action'=>'deleted'));
$url->setParams(array('a'=>'1', 'a'=>'1'));
$url->setParams('iuy=125&fsd[1]=15');
$url->setParams(array('iuy'=>125, 'fsd[15]'=>15));

echo $url->get();
echo "<pre>"; print_r($url); echo "</pre>";
*/

?>
