<?php
//************************************************************************************
//** CryptEmail.php - Email Build Class
//** This file contains the email build function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class CryptEmail
{

	function getMailtolJs($use_script_tag = false) {
		$html = <<<EOF
		function namylo (domen, server, login, sub) {
			eml = "mailto:" + login +  "@" + server + "." + domen;
			if(sub != "") eml += "?subject=" + sub;
			window.location.href = eml;
		}\n
EOF;
	
		$html = ($use_script_tag) ? "\n<SCRIPT>\n".$html."\n</SCRIPT>\n" : $html;
		return $html;
	}

	
	function getMailto($email, $subj = false) {
		$chunks = explode('@', $email);
		
		$pos = strrpos($chunks[1], '.');
		$server = substr($chunks[1], ($pos+1));
		$domen = substr($chunks[1], 0, $pos);
		
		$str = "javascript:namylo('%s', '%s','%s', '%s');";
		return sprintf($str, $server, $domen, $chunks[0], $subj);
	}
	
	
	function getMailtoLink($email, $text, $subj = false) {
		$str = '<a href="%s">%s</a>';
		return sprintf($str, CryptEmail::getMailto($email, $subj), $text);
	} 
	
}


//echo CryptEmail::getMailtoLink('info@das.hag.com', 'text');
?>