<?php
//************************************************************************************
//** FileUtil.php - File Utility Class
//** This file contains the reading and writing file function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class FileUtil
{	


   /*
    * read -- get data from file.
    *
    * @param    string    $filename    filename to read
    *
    * @return   string    data from file or false on failure
    * @access   public
    */
	
function read($filename) {

		$data = false;
		if($fp = @fopen($filename, "rb")) {
			$data = fread($fp, filesize($filename));
			fclose($fp);
		}
		return $data;
	}


   /*
    * write -- write data to file.
    *
    * @param    string    $filename    filename to write
    * @param    string    $data        data to write
    * @param    bool      true/false   truncate file or not
    * 
    * @return   boolean   true/false
    * @access   public
    */
	
function write($filename, $data, $truncate = true) {	
	
		$ret = false;
		if($fp = @fopen($filename, 'ab')) {
			flock($fp, LOCK_EX);
			
			if($truncate) {
				ftruncate ($fp, 0);
			}
			
			fputs($fp, $data);
			fflush($fp);
			flock($fp, LOCK_UN);
			fclose($fp);
			$ret = true;
		}
		return $ret;
	}
	
} // <-- end
?>