<?php
//************************************************************************************
//** GetMsg.php - Get Message Class
//** This file contains the get message function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class GetMsg
{	

	var $file_type = 'php'; // also php, multi_ini
	var $types = array('ini'=>'parseIni', 'multi_ini'=>'parseMultiIni', 'php'=>'parsePhp');
	var $extensions = array('ini'=>'ini', 'multi_ini'=>'ini', 'php'=>'php');
	
	
	function GetMsg($dir = '', $type = 'php') {
		$this->setFileDir($dir);
		$this->setFileType($type);
	}
	
	
	function setFileType($type) {
		$this->file_type = $type;
	}
	
	
	function setFileDir($dir) {
		$this->file_dir = $dir;
	}
	
	
	function & get($file_key, $key_1 = false, $key_2 = false) {
		$func = $this->types[$this->file_type];
		$file = $this->_getFilePath($file_key);
		
		return GetMsgHelper::$func($file, $key_1, $key_2);
	}
		
	
	function _getFilePath($file_key) {
		return $this->file_dir . $file_key . '.' . $this->extensions[$this->file_type];
	}
}




// helpers
class GetMsgHelper
{

	function &parseIni($file, $key = false, $process_sections = 1) {
		$arr = parse_ini_file($file, $process_sections);
		$arr = ($key) ? (!empty($arr[$key])) ? $arr[$key] : array() : $arr;
		return $arr;
	}
	

	// parse multilines ini file
	// it will skip all before defining first [block]
	function &parseMultiIni($file, $key = false) {
		$s_delim = '[';
		$e_delim = ']'; 
		
		$str = implode('',file($file));
		if($key && strpos($str, $s_delim . $key . $e_delim) === false) { 
			$t = '';
			return $t; 
		} 
		
		$str = explode($s_delim, $str);
		$num = count($str);
			
		for($i=1;$i<$num;$i++){
			$section = substr($str[$i], 0, strpos($str[$i], $e_delim));
			$arr[$section] = substr($str[$i], strpos($str[$i], $e_delim)+strlen($e_delim));
		}
		
		$t = ($key) ? @$arr[$key] : $arr;
		return $t;
	}
	
	
	// just require php file with array in it
	function & parsePhp($file, $arr, $key = false) {
		require_once ($file);
		$arr =& $$arr;
		return ($key) ? $arr[$key] : $arr;
	}
}

//$msg = new GetMsg();
//$msg =& $msg->get('test', 'keysss');
//echo "<pre>"; print_r($msg); echo "</pre>";
?>