<?php
//************************************************************************************
//** LetterTemplate.php - Letter Template Class
//** This file contains the letter template function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class LetterTemplate extends AppObj
{
	
	var $properties = array('id'		 	=> NULL,
							'title'	 		=> '',
							'subject'		=> '',
							'body' 			=> '',
							'description'	=> '',
							'from_email'	=> '',
							'from_name'		=> '',
							'to_email'		=> '',
							'to_name'		=> '',
							'to_cc_email'	=> '',
							'to_cc_name'	=> '',
							'to_bcc_email'	=> '',
							'to_bcc_name'	=> '',
							'letter_key'	=> '',
							'skip_field'	=> '',
							'is_html'		=> 0,
							'in_out'		=> 1,
							'predifined'	=> 0,
							'active'		=> 1
							);
	
	
	var $hidden = array('id', 'predifined', 'letter_key', 'is_html', 'skip_field');
	
	
	function validate($values) {
		
		require_once 'jumper_lib/Validator.php';
		
		$required = array('subject', 'body');
		if(!$values['predifined']) {
			$required[] = 'title';
		}
		
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
	
}
?>