<?php
//************************************************************************************
//** LetterTemplateView_form.php - Letter Template View Form Class
//** This file contains the letter template view form function written by Evgen 
//** Leontev (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class LetterTemplateView_form extends AppView
{
	
	var $template = 'form.html';
	
	function execute(&$obj, &$manager) {
		
		$this->addMsg('common_msg.ini', 'email_setting');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		// template tags
		$p = new AppMailParser();
		$tags = '[' . implode('], [', $p->getVars()) . ']';
		$msgs = array('title'=>$this->msg['template_tags'], 'body'=>$tags);
		$tpl->tplAssign('error_msg', BoxMsg::factory('hint', $msgs));
		
		
		if($obj->get('is_html')) {
			$tpl->tplAssign('fck_editor', $this->getHtmlArea($obj->get('body')));
		} else {
			$tpl->tplAssign('fck_editor', $this->getTextArea($obj->get('body')));
		}
		
		if($obj->get('predifined')) {
			$tpl->tplSetNeeded('/title_text');
			$tpl->tplSetNeeded('/description_text');
		} else {
			$tpl->tplSetNeeded('/title_input');
			$tpl->tplSetNeeded('/description_input');		
		}
		
		
		$skip_block = array('from', 'to', 'to_cc', 'to_bcc');
		$skip = explode(',', $obj->get('skip_field'));
		foreach($skip_block as $k => $v) {
			if(!in_array($v, $skip)) {
				$tpl->tplSetNeeded('/' . $v);
			} else {
				$obj->hidden[] = $v;
			}
		}
		
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign(AppMailParser::getTemplateMsg($obj->get('letter_key')));
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getHtmlArea(&$value) {
		
		require_once APP_ROOT_DIR . 'tools/FCKeditor/fckeditor.php';
		
		$oFCKeditor = new FCKeditor('body');
		
		if(!$oFCKeditor->IsCompatible()) {
			$this->controller->go('editor_incompatible', true);
		}
		
		$oFCKeditor->BasePath = APP_HOME_PATH . 'tools/FCKeditor/';
		$oFCKeditor->ToolbarSet = 'Default';
		$oFCKeditor->ToolbarSet = 'LetterTemplate';
		$oFCKeditor->Width  = '100%';
		$oFCKeditor->Height = '300';
		$oFCKeditor->Value	= &$value;
		
		return $oFCKeditor->CreateHtml();	
	}
	
	
	function getTextArea($value) {
		$str = '<textarea cols="60" rows="20" name="body" style="width: %s;">%s</textarea>';
		return sprintf($str, '100%', $value);
	}
}
?>