<?php
//************************************************************************************
//** Feedback.php - Feedback Class
//** This file contains the feedback function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class Feedback extends AppObj
{
	
	var $properties = array('id'		 	=> NULL,
							'user_id'		=> '',
							'admin_id'		=> '',
							'category_id'	=> '',
							'name'	 		=> '',
							'email'	 		=> '',
							'question'	 	=> '',
							'attachment'	=> '',
							'answer' 		=> '',
							'date_posted'	=> '',
							'date_answered'	=> '',
							'answered'		=> 0,
							'placed'		=> 0
							);
	
	var $hidden = array('id', 'admin_id', 'user_id', 'date_posted', 
	                    'category_id', 'name', 'email', 'question', 'attachment');
	
	
	function _callBack($property, $val) {
		if($property == 'date_answered' && !$val) {
			$val = date('Y-m-d H:i:s');
		} elseif($property == 'admin_id' && !$val) {
			$val = $_SESSION['auth_']['user_id'];
		}
		
		return $val;
	}
	
	
	function validate($values) {
		
		require_once 'jumper_lib/Validator.php';
		
		$required = array('answer');
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
}
?>