<?php
//************************************************************************************
//** FeedbackView_form.php - Feedback View Form Class
//** This file contains the feedback view form function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'core/app/AppMailSender.php';


class FeedbackView_form extends AppView
{
	
	var $template = 'form.html';
	
	
	function execute(&$obj, &$manager, $data) {
		
		$this->addMsg('letter_template_msg.ini');
		$this->addMsg('common_msg.ini', 'knowledgebase');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		$obj->set('question', nl2br($obj->get('question')));
		
		
		if($obj->get('user_id')) {
			$name = $data['first_name'] . ' ' . $data['last_name'];
			$tpl->tplAssign('first_name', $data['first_name']);
			$tpl->tplAssign('last_name', $data['last_name']);
			$tpl->tplAssign('username', $data['username']);
			$tpl->tplAssign('show_name', $name . ' - ' . $data['username']);
			$obj->set('name', $name);
		} else {
			$tpl->tplAssign('show_name', $obj->get('name'));
		}

		
		// attachment
		if($obj->get('attachment')) {
			$files = explode(';', $obj->get('attachment'));
			foreach($files as $k => $file) {
				$filename = basename($file);
				$link = $this->getActionLink('file', $obj->get('id'), array('f' => $k));
				$files[$k] = sprintf('<a href="%s">%s</a>', $link, $filename);
			}
			
			$tpl->tplAssign('files', implode('<br />', $files));
		}


		// answer
		$sender = &new AppMailSender();
		$sender->letter_key = 'answer_to_user';
		$parser = &$sender->parser;
		$parser->assign(array_merge($obj->get(), $data));	
		
		$obj->set('answer', $parser->parse($sender->getTemplate()));
				
		
		$tpl->tplAssign($this->setCommonFormVars($obj, '', $this->msg['answer_to_user_msg']));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
}
?>