<?php
//************************************************************************************
//** SettingParser.php - Setting Parser Class
//** This file contains the parser setting function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class SettingParser extends SettingParserCommon
{		

	function parseIn($key, $value) {
		
		if($key == 'file_dir') {
			$value = $value . '/';
			$pattern = array();
			$pattern[] = '#\\\\#';
			$pattern[] = '#/{2,}#';
			
			$value = preg_replace($pattern, '/', $value);
		
		} elseif($key == 'file_denied_extensions') {
			$value = str_replace(array(' ', '  '), '', $value);
		
		} elseif($key == 'file_allowed_extensions') {
			$value = str_replace(array(' ', '  '), '', $value);
		
		// set max size nor more than upload_max_filesize
		} elseif($key == 'file_max_filesize') {
		
			// upload_max_filesize "2M" PHP_INI_SYSTEM|PHP_INI_PERDIR 
			$size = ini_get('upload_max_filesize')*1024;
			$value = ($value > $size) ? $size : $value; 
		}
		
		return $value;
	}
	
	
	function parseOut($key, $value) {
	
		if(APP_DEMO_MODE && $key == 'file_dir') {
			$value = '- - - - - - - - - - -';
		}
	
		return $value;
	}
	
	
	// when display
	function skipSettingDisplay($key, $value = false) {
		$ret = false;
		$files_settings = array('show_num_entries',
								'category_sort_order',
								'num_entries_per_page',
								'num_recently_posted_entries',
								'num_most_viewed_entries',
								'num_category_cols',
								'private_policy',
								'file_extract');
		
		if(in_array($key, $files_settings) && !$this->model->isExtra('file')) {
			$ret = true;
		
		} elseif($key == 'private_policy' && !$this->model->isExtra('private')) {
			$ret = true;
		}
		
		
		
		return $ret;
	}	
}
?>
