<?php
//************************************************************************************
//** PageController1.php - Bulk Page Controller One Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

$file_conf['extract_save_dir'] = APP_CACHE_DIR;

require_once 'jumper_lib/Dir/MyDir.php';

$controller->loadClass('FileCategoryModel', 'file/category');
$controller->loadClass('RoleModel', 'role');

$controller->loadClass('FileEntry', 'file/entry');
$controller->loadClass('FileEntryModel', 'file/entry');
$controller->loadClass('FileEntryModel_dir', 'file/entry');
$controller->loadClass('FileEntryView_common', 'file/entry');
//$controller->loadClass('FileEntryModel_db');

$controller->loadClass('BulkFileEntry');

// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

// settings
$setting = &new SettingModel();
$setting->setModuleId('file');
$setting =& $setting->getSettings();
$setting = array_merge($setting, $file_conf);

$obj = new BulkFileEntry;

$manager =& $obj->setManager( new FileEntryModel_dir );
$manager->setFileSetting($setting);

$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	
	$controller->go();

	break;
	

case 'insert': // ------------------------------
	
	
	$controller->go();

	break;
	
	
default: // ------------------------------------
	
	$files = array();
	$next = false;
	
	if(isset($rp->submit)) {
			
		$is_error = &$obj->validate($rp->vars, $rp->step);
		
		if($is_error) {
			$rp->stripVars(true);
			
			$obj->set($rp->vars);
			$obj->setCategory(@$rp->vars['category']);
			$obj->setCategoryMirror(@$rp->vars['category_mirror']);
			$obj->setMemberRole(@$rp->vars['member_role']);
		
		} else {
		
			set_time_limit(0);
			ignore_user_abort();
			
			$rp->stripVars('striplashes');
			
			$obj->set($rp->vars);
			$obj->setCategory(@$rp->vars['category']);
			$obj->setCategoryMirror(@$rp->vars['category_mirror']);
			
			
			if($rp->step == 1) {
				$files = &$manager->readDirectory($obj->get('directory'));
				$next = true;
				if(!$files) {
					$next = false;
					$obj->errors[0]['msg'] = 'no_files_in_directory';
				}
			}
			
			if($rp->step == 2) {
				
				foreach($rp->files as $k => $file) {
					
					$upload = $manager->getFileData($file);
					$content = &$manager->getFileContent($upload['to_read']);
					
					if($content) {
	
						$file_id = $manager->saveFileData($content);
						
						$obj->set('id', $file_id);
						$obj->set('filename', addslashes($upload['name']));
						$obj->set('directory', $upload['directory']);
						$obj->set('filesize', $upload['size']);
						$obj->set('filetype', $upload['type']);
						$obj->setMemberRole(@$rp->vars['member_role']);
						
						if($manager->isExtra('file')) {
							if($manager->setting['file_extract']) {
								
								$controller->loadClass('FileTextExctractor');
								
								$extractor = &new FileTextExctractor($upload['extension']);
								$extractor->setTool($setting['extract_tool']);
								$extractor->setExtractDir($setting['extract_save_dir']);
								
								$obj->set('filetext', addslashes($extractor->getText($upload['to_read'])));
							}
						}
						
						$manager->save($obj, 'insert', true);
					}
				}
				
				$return = $controller->getLink('file', 'file_entry');
				$controller->setCustomPageToReturn($return);
				$controller->go();
			}
		}
	}
	
	if($next) {
		$view = &$controller->getView($obj, $manager, 'BulkFileEntryView_two', $files);
	} else {
		$view = &$controller->getView($obj, $manager, 'BulkFileEntryView_one');
	}
	
}
?>