<?php
//************************************************************************************
//** BulkFileEntryView_two.php - Bulk File Entry View Two Class
//** This file contains the bulk file entry function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'core/app/AppAjax.php';
require_once 'core/common/CommonEntryView.php';


class BulkFileEntryView_two extends AppView
{
	
	var $template = 'form_two.html';
	
	function execute(&$obj, &$manager, $files) {
		
		$this->addMsg('user_msg.ini');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors, $this->controller->module));
		
		// categories
		FileEntryView_common::parseCategories($obj, $manager, $tpl);		
		
		// member roles
		if($manager->isExtra('private')) {
			require_once APP_EXTRA_MODULE_DIR . 'private/PrivateFile.php';
			PrivateFile::getFormStaff($tpl, $manager);
		}
		
		//files ajax
		ini_set('arg_separator.output', '&amp;'); // required for IIS
		
		$this->manager = &$manager;
		$xajax = &new AppAjax();
		//$xajax->debugOn();
		$xajax->setRequestURI($this->controller->getLink('all'));
		$xajax->registerFunction(array('getFileList', $this, 'ajaxGetFileList'));
		$xajax_js = $xajax->getJavascript();
		$xajax->processRequests();

		$tpl->tplAssign('xajax_js', $xajax_js);
		
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getFileList($files) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'file_list.html');
		
		foreach($files as $v) {
			$a['filename'] = $v;
			$a['size'] = filesize($v);
			$tpl->tplParse($a, 'row');
		}
		
		$tpl->tplParse($this->msg);
		return $tpl->tplPrint(1);		
	}
	
	
	function ajaxGetFileList($directory) {
		
		$files = $this->manager->readDirectory($directory);
		
		if(APP_DEMO_MODE) {
			$msgs = AppMsg::getMsgs('after_action_msg.ini', false, 'not_allowed_demo');
			$files = BoxMsg::factory('error', $msgs);
		
		} elseif($files) {
			$files = $this->getFileList($files);
		
		} else {
			
			$msgs = AppMsg::getMsgs('error_msg.ini', $this->controller->module);
			if(!is_readable($directory)) {
				$msg['body'] = $msgs['dir_not_readable_msg'];
			} else {
				$msg['body'] = $msgs['no_files_in_directory'];
			}

			$files = BoxMsg::factory('error', $msg);
		}
		
		
		$objResponse = new xajaxResponse();
		$objResponse->setCharEncoding($this->encoding);
		
		//$objResponse->addAlert($directory);
		$objResponse->addAssign("file_root", "innerHTML", $files);
	
		return $objResponse;	
	}
}
?>