<?php
//************************************************************************************
//** PageController.php - Category Page Controller Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

$controller->loadClass('FileCategory');
$controller->loadClass('FileCategoryModel');
$controller->loadClass('RoleModel', 'role');

// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new FileCategory;

$manager =& $obj->setManager(new FileCategoryModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	$msg = $manager->delete($rq->id, $rq->parent_id);
	
	$success = ($msg == 'success') ? false : true;
	$controller->go($msg, $success);

	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars);
		
		if($is_error) {
			$rp->stripVars(true);
			$obj->set($rp->vars);
			
			$obj->setMemberRole(@$rp->vars['member_role']);
			
			//if(!empty($rp->vars['admin_user'])) {
			//	$ids = implode(',', $rp->vars['admin_user']);	
			//	$obj->setAdminUser($manager->getAdminUserByIds($ids));
			//}	
		
		} else {
			$rp->stripVars();
			$obj->set($rp->vars);
			//$obj->setAdminUser(@$rp->vars['admin_user']);
			$obj->setMemberRole(@$rp->vars['member_role']);
		
			$manager->save($obj, $controller->action);
			
			$controller->go();
		}
		
	} elseif($controller->action == 'update') {
	
		$data = &$manager->getById($rq->id);
		$rp->stripVarsValues($data);
		$obj->set($data);
		
		if($manager->isExtra('private')) {
			$obj->setMemberRole($manager->getMemberRoleById($rq->id));
		}
		
		//if($manager->isExtra('notify_admin_category')) {
		//	$obj->setAdminUser($manager->getAdminUserById($rq->id));
		//}
	}
	
	$view = &$controller->getView($obj, $manager, 'FileCategoryView_form');

	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'FileCategoryView_list');
}
?>