<?php
//************************************************************************************
//** FileCategory.php - File Category Class
//** This file contains the file category function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class FileCategory extends AppObj
{
	
	var $properties = array('id'		 	=> NULL,
							'parent_id' 	=> 0,
							'name' 			=> '',
							'description'	=> '',
							'sort_order' 	=> 0,
							'private'		=> 0,
							'active'		=> 1
							);
	
	
	var $hidden = array('id');
	var $member_role = array();
	
	
	function getMemberRole() {
		return $this->member_role;
	}
	
	function setMemberRole($role) {
		$this->member_role = $role;
	}		
	
	function validate($values) {
		
		require_once 'jumper_lib/Validator.php';
		
		$required[] = 'name';
		
		if($values['parent_id'] != 0) {
			$required[] = 'parent_id';
		}
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
	
}
?>