<?php
//************************************************************************************
//** FileCategoryModel.php - File Category Model Class
//** This file contains the file category model function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'core/app/DataToValueModel.php';
require_once 'jumper_lib/Util/TreeHelper.php';
require_once 'jumper_lib/SQL/TableSortOrder.php';
require_once 'core/common/CommonCategoryModel.php';


class FileCategoryModel extends CommonCategoryModel
{
	var $tbl_pref_custom = 'file_';
	var $tables = array('table'=>'category', 'category', 'entry', 'entry_to_category');
	var $custom_tables = array('data_to_user_rule', 'data_to_user_value', 'user', 'role');
	
	
	function FileCategoryModel() {
		parent::CommonCategoryModel();
		$this->dv_manager = &new DataToValueModel();
	}
	
	
	// FOR FORM SELECT // ---------------------
	
	// just for select
	function &getSelectRecords($sort = false) { 
	
		$sort = ($sort) ? $sort : 'sort_order';
	
		$sql = "SELECT id as id1, id, parent_id, name, sort_order, private 
		FROM {$this->tbl->category} c
		ORDER BY {$sort}";
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return $result->GetAssoc();
	}
	
	
	// CATEGORY TO MEMBER ROLE // -----
	
	function getMemberRoleById($record_id, $list_view = false) {

			$select = ($list_view) ? 'dv.data_value AS k, r.title AS v' : 'r.id, r.id AS id1';
			return $this->dv_manager->getDataById($record_id, 
		                                   		 'file_category_to_member_role', 
		                                         "{$this->tbl->role} r", 
										         'r.id',
												 $select,
												 $list_view);
	}
	
	
	function saveMemberRoleToCategory($obj, $record_id) {
		$this->dv_manager->saveData($obj->getMemberRole(), $record_id, 'file_category_to_member_role');
	}
	
	
	function deleteMemberRoleToCategory($record_id) {
		$this->dv_manager->deleteData($record_id, 'file_category_to_member_role');
	}	
	
	
	// ACTIONS // ---------------------------
	
	
	
	// DELETE RELATED // ---------------------


}
?>