<?php
//************************************************************************************
//** FileCategoryView_form.php - File Category View Form Class
//** This file contains the file category view form function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once "core/app/AppAjax.php";


class FileCategoryView_form extends AppView
{
	var $tmpl = 'form.html';
	
	
	function execute(&$obj, &$manager) {
		
		$this->addMsg('user_msg.ini');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		$rows = &$manager->getSelectRecords();
		$range = &$manager->getSelectRange($rows);
		$js_values =& $manager->getSortJsArray($rows);
		
		foreach($js_values as $k => $v) {
			$a['js_option_list_values'] = $v;
			$key = ($obj->get('id')) ? $obj->get('sort_order') : 'sort_end';
			$a['js_option_default'] = sprintf("'%s', '%s'", $k, $key);
			$tpl->tplParse($a, 'js_option_list');
		}
		
		
		$select = new FormSelect();
		$select->setSelectWidth(250);
		$select->select_tag = false;
		
		// set disabled for self
		if($obj->get('id')) { 
			$select->setOptionParam($obj->get('id'), 'disabled');
		}
		
		$select->setMultiple(5, false);
		$select->setSelectName('parent_id');
		$select->setRange($range, array(0=>$this->msg['top_level_msg']));
		$tpl->tplAssign('category_select', $select->select($obj->get('parent_id')));
		
		
		// member roles
		if($manager->isExtra('private')) {
		
			$select->resetOptionDisabled();
			$select->setSelectName('member_role');
			$select->setRange($manager->getMemberRoleSelectRange());
			$tpl->tplAssign('member_role_select', $select->select($obj->getMemberRole()));
			
			//xajax
			$xajax = &new AppAjax();
			//$xajax->debugOn();
			$xajax->registerFunction(array('addParentRoles', $this, 'ajaxAddParentRoles'));
			$xajax_js = $xajax->getJavascript();
			$xajax->processRequests();
			
			$tpl->tplSetNeededGlobal('private');
			$tpl->tplAssign('xajax_js', $xajax_js);
			$tpl->tplAssign('private_options', $this->getChecked($obj->get('private')));
		}		
		
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));		
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function ajaxAddParentRoles($category_id) {
		
		if($category_id == 0) { 
			$objResponse = new xajaxResponse();
			return $objResponse;
		}
		
		
		$manager = &new FileCategoryModel();
		
		$roles_ids = false;
		$is_private = $manager->isPrivate($category_id);
		if($is_private) {
			$roles_ids = implode(',', $manager->getMemberRoleById($category_id));
		}
		
		$objResponse = new xajaxResponse();
		
		//$objResponse->addAlert($category_id);
		//$objResponse->addAlert($is_private);
		//$objResponse->addAlert($roles_ids);
		
		$objResponse->addScriptCall('AssignPrivateFromParent', $is_private, $roles_ids);
	
		return $objResponse;	
	}	
}
?>
