<?php
//************************************************************************************
//** FileEntry.php - File Entry Class
//** This file contains the file entry function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class FileEntry extends AppObj
{
	
	var $error;
	
	var $properties = array('id'		=> '',
							'filename'		=> '',
							'filesize'		=> '',
							'filetype'	 	=> '',
							'title' 		=> '',
							'description'	=> '',
							'description_full'	=> '',
							'filetext'		=> '',
							'comment'		=> '',
							'downloads'		=> 0,
							'date_posted'	=> '',
							'directory'		=> '',
							'sub_directory'	=> '',
							'creator_id'		=> '',
							'updater_id'	=> '',
							'sort_order'	=> 0,
							'private'		=> 0,
							'active'		=> 1
							);
	
	//, 'creator_id', 'updater_id', 'date_posted'
	var $hidden = array('id', 'creator_id', 'updater_id', 
	                    'filename', 'filesize', 'filetype', 'downloads', 'date_posted', 'subdir');
	var $category = array();
	var $category_mirror = array();
	var $text;
	var $member_role = array();
	
	
	function setCategoryMirror($val) {
		$this->category_mirror = &$val;
	}
	
	function &getCategoryMirror() {
		return $this->category_mirror;
	}	
	
	function setCategory($val) {
		$this->category = &$val;
	}
	
	function &getCategory() {
		return $this->category;
	}
	
	function getMemberRole() {
		return $this->member_role;
	}
	
	function setMemberRole($role) {
		$this->member_role = $role;
	}	
	
	
	
	function _callBack($property, $val) {
	
		if($property == 'date_posted' && !$val) {
			$val = date('Y-m-d H:i:s');
		
		} elseif($property == 'creator_id' && !$val) {
			$val = $_SESSION['auth_']['user_id'];
		
		} elseif($property == 'updater_id') {
			$val = $_SESSION['auth_']['user_id'];
		} 
		
		return $val;
	}
	
	
	function validate($values, $action) {
		
		require_once 'jumper_lib/Validator.php';
		
		$required = array('category');
		
		if($action == 'insert') {
			$required[] = 'file';
			$values['file'] = $_FILES['file_1']['name'];
		}
		
		if($action == 'bulkadd') {
			$values['directory'] = str_replace(array('/', '.', '..'), '', $values['directory']);
			$required[] = 'directory';
		}		
		
		$v =& new Validator($values, true);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
		
		
		if($action == 'bulkadd') {
			if(!is_readable($values['directory'])) {
				$v->setError('dir_not_readable_msg', 'directory');
			}
		}
		
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
}
?>