<?php
//************************************************************************************
//** FileEntryView_form.php - File Entry View Form Class
//** This file contains the file entry form function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'core/app/AppAjax.php';
require_once 'core/common/CommonEntryView.php';


class FileEntryView_form extends AppView
{
	
	var $template = 'form.html';
	
	function execute(&$obj, &$manager) {
		
		$this->addMsg('user_msg.ini');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->template);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		if($obj->error) {
			$tpl->tplAssign('error_msg', $obj->error);
		}
		
/*
		$oFCKeditor = new FCKeditor('body');
		
		if(!$oFCKeditor->IsCompatible()) {
			$this->controller->go('editor_incompatible', true);
		}
		
		$oFCKeditor->BasePath = APP_HOME_PATH . 'tools/FCKeditor/';
		$oFCKeditor->ToolbarSet = 'File';		
		$oFCKeditor->Width  = '100%' ;
		$oFCKeditor->Height = '300' ;
		$oFCKeditor->Value	= &$obj->get('body');	
		
		$tpl->tplAssign('fck_editor', $oFCKeditor->CreateHtml());	
*/		
		
		// categories
		FileEntryView_common::parseCategories($obj, $manager, $tpl);
		
				
		// member roles
		if($manager->isExtra('private')) {
			require_once APP_EXTRA_MODULE_DIR . 'private/PrivateFile.php';
			PrivateFile::getFormStaff($tpl, $manager);
		}
		
		if($this->controller->action == 'update') {
			$tpl->tplSetNeeded('/filename');
		}		
		
		
		$tpl->tplAssign('file_size_max', WebUtil::getFileSize($manager->setting['file_max_filesize']*1024));
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function ajaxGetCategoryRoles($category_id) {
		$manager = &new FileCategoryModel();
		return CommonEntryView::ajaxGetCategoryRoles($category_id, $manager);
	}
	
	
	function getPrivateCategoryMsg(&$manager, $category_id) {
		return CommonEntryView::getPrivateCategoryMsg($manager, $category_id);
	}
}
?>