<?php
//************************************************************************************
//** SettingValidator.php - Setting Validator Class
//** This file contains the setting validator function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'jumper_lib/Validator.php';


class SettingValidator
{
	 
	function validate($values) {
		
		//$required = array('support_email');

		
		$v =& new Validator($values, true);
		
		//$v->required('required_msg', $required);
		//$v->regex('email_msg', 'email', 'support_email');
		
		if(!$this->isFileExists($values['page_to_load'])) {
			$v->setError('page_not_exists_msg', '');
		}
		
		return $v->getErrors();
	}
	

	
	// check is page exists and reachable 
	function isFileExists($file) {
		
		$ret = true;
		
		if('default' != strtolower($file)) {
				
			$files = explode(';', $file);
			$files = (!$files) ? $files = array($file) : $files;
			
			foreach($files as $val) {
				if(@!fopen(trim($val), "rb")) {
					$ret = false;
					break;
				}					
			}
		}		

		return $ret;
	}
}
?>