<?php
//************************************************************************************
//** JMPCategoryModel.php - Category Model Class
//** This file contains the category model function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'core/app/DataToValueModel.php';
require_once 'jumper_lib/Util/TreeHelper.php';
require_once 'jumper_lib/SQL/TableSortOrder.php';
require_once 'core/common/CommonCategoryModel.php';


class JMPCategoryModel extends CommonCategoryModel
{
	var $tbl_pref_custom = 'jmp_';
	var $tables = array('table'=>'category', 'category', 'entry', 'entry_to_category');
	var $custom_tables = array('data_to_user_rule', 'data_to_user_value', 'user', 'role');
	
	
	function JMPCategoryModel() {
		parent::CommonCategoryModel();
		$this->dv_manager = &new DataToValueModel();
	}
	
	
	// CATEGORY TO USER
	
	function getAdminUserById($record_id) {
			return $this->dv_manager->getDataById($record_id, 
		                                   'jmp_category_to_admin', 
		                                   "{$this->tbl->user} u",
										   'u.id',
										   'u.id, CONCAT(u.first_name, " ", u.last_name)');
	}
	
	
	function saveAdminUserToCategory($obj, $record_id) {
		$this->dv_manager->saveData($obj->getAdminUser(), $record_id, 'jmp_category_to_admin');
	}
	
	
	function deleteAdminUserToCategory($record_id) {
		$this->dv_manager->deleteData($record_id, 'jmp_category_to_admin');
	}
	
	// used when wrong submit to generate list 
	function getAdminUserByIds($ids) {
		$sql = "SELECT u.id, CONCAT(u.first_name, ' ', u.last_name) 
		FROM {$this->tbl->user} u
		WHERE u.id IN ($ids)";
			
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return $result->GetAssoc();	
	}
	
	
	// CATEGORY TO MEMBER ROLE // -----
	
	function getMemberRoleById($record_id, $list_view = false) {

			$select = ($list_view) ? 'dv.data_value AS k, r.title AS v' : 'r.id, r.id AS id1';
			return $this->dv_manager->getDataById($record_id, 
		                                   		 'jmp_category_to_member_role', 
		                                         "{$this->tbl->role} r", 
										         'r.id',
												 $select,
												 $list_view);
	}
	
	
	function saveMemberRoleToCategory($obj, $record_id) {
		$this->dv_manager->saveData($obj->getMemberRole(), $record_id, 'jmp_category_to_member_role');
	}
	
	
	function deleteMemberRoleToCategory($record_id) {
		$this->dv_manager->deleteData($record_id, 'jmp_category_to_member_role');
	}
	

	// ACTIONS // ---------------------
}
?>