<?php
//************************************************************************************
//** PageController.php - Comment Page Controller Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once $controller->working_dir . 'inc/JMPComment.php';
require_once $controller->working_dir . 'inc/JMPCommentModel.php';


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new JMPComment;

$manager =& $obj->setManager(new JMPCommentModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);



switch ($controller->action) {
case 'delete': // ------------------------------
	
	$manager->delete($rq->id);
	$controller->go();

	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars);
		
		if($is_error) {
			$rp->stripVars(true);
			$obj->set($rp->vars);
		
		} else {
			$rp->stripVars();
			$obj->set($rp->vars);
		
			$manager->save($obj);
			
			$controller->go();
		}
		
		
	} elseif($controller->action == 'update') {
	
		$data = &$manager->getById($rq->id);
		$rp->stripVarsValues($data);
		$obj->set($data);	
	}
	
	
	$view = &$controller->getView($obj, $manager, 'JMPCommentView_form');

	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'JMPCommentView_list');
}
?>