<?php
//************************************************************************************
//** JMPComment.php - Comment Class
//** This file contains the comment function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class JMPComment extends AppObj
{


	var $properties = array('id'		 	=> NULL,
							'user_id'		=> '',
							'entry_id' 		=> '',
							'name'	 		=> '',
							'email' 		=> '',
							'comment' 		=> '',
							'date_posted'	=> '',
							'active'		=> 1
							);
	
	var $hidden = array('id','user_id','entry_id','date_posted');
	var $title;
	var $username;
	var $r_email;
	
	
	function _callBack($property, $val) {
		if($property == 'date_posted' && !$val) {
			$val = date('Y-m-d');
		}
		
		return $val;
	}
	
	
	// so we extend base set function
	function set($key_or_arr, $value = false) {
		parent::set($key_or_arr, $value);
		
		$this->title = $key_or_arr['title'];
		$this->username = $key_or_arr['username'];
		$this->r_email = $key_or_arr['r_email'];
	}
	
	
	function validate($values) {
		
		require_once 'jumper/Validator.php';
		
		$required = array('comment');
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
		
		$v->regex('email_msg', 'email', 'email', false);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
	
}
?>