<?php
//************************************************************************************
//** JMPCommentModel.php - Comment Model Class
//** This file contains the comment model function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class JMPCommentModel extends AppModel
{
	
	var $tbl_pref_custom = 'jmp_';
	var $tables = array('table'=>'comment', 'comment', 'entry');
	var $custom_tables = array('user'=>'member');
	
	
	function getById($record_id) {
		$sql = "
		SELECT 
			c.*, 
			e.title,
			u.username,
			u.email AS r_email,
			UNIX_TIMESTAMP(c.date_posted) AS ts
		FROM 
			({$this->tbl->comment} c, 
			{$this->tbl->entry} e)
			LEFT JOIN {$this->tbl->user} u ON c.user_id = u.id
		WHERE 
			e.id = c.entry_id
			AND c.id = ?";
		$result = &$this->db->Execute($sql, $record_id) or die(db_error($sql));
		return $result->FetchRow();
	}
	

	function getRecordsSql() {
		
		$sql = "
		SELECT 
			c.*, 
			e.title,
			u.username,
			u.email AS r_email,
			UNIX_TIMESTAMP(c.date_posted) AS ts,
			CONCAT(SUBSTRING_INDEX(c.comment,' ',20), '...') AS comment
		FROM 
			({$this->tbl->comment} c, 
			{$this->tbl->entry} e)
			LEFT JOIN {$this->tbl->user} u ON c.user_id = u.id
		WHERE 
			e.id = c.entry_id  
			AND {$this->sql_params}
			{$this->sql_params_order}";
		
		//echo "<pre>"; print_r($sql); echo "</pre>";
		return $sql;
	}		
	
	
	
	
	
	// ACTIONS // ---------------------
	
	
	
	
	// DELETE RELATED // ---------------------
		
}
?>
