<?php
//************************************************************************************
//** JMPEntry.php - Entry Class
//** This file contains the knowledgebase entry function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class JMPEntry extends AppObj
{
	
	var $properties = array('id'		 		=> NULL,
							'creator_id' 		=> '',
							'updater_id'		=> '',
							'title'	 			=> '',
							'body' 				=> '',
							'date_posted'		=> '',
							//'date_updated'	=> '',
							'meta_keywords'		=> '',
							'meta_location'		=> '',
							'meta_link'		=> '',
							'meta_datatype'		=> '',
							'url_title' 		=> '',
							'hits'				=> 0,
							'sort_order'		=> 'sort_end',
							'private'			=> 0,
							'active'			=> 1
							);
	
	var $hidden = array('id', 'creator_id', 'updater_id', 'date_posted', 'hits');
	var $category = array();
	var $category_mirror = array();	
	var $attachment = array();
	var $related = array();
	var $member_role = array();
	
	
	function setCategoryMirror($val) {
		$this->category_mirror = &$val;
	}
	
	function &getCategoryMirror() {
		return $this->category_mirror;
	}
	
	function setCategory($val) {
		$this->category = &$val;
	}
	
	function &getCategory() {
		return $this->category;
	}
	
	function getMemberRole() {
		return $this->member_role;
	}
	
	function setMemberRole($role) {
		$this->member_role = $role;
	}
	
	function setAttachment($val) {
		$this->attachment = &$val;
	}
	
	function &getAttachment() {
		return $this->attachment;
	}

	function setRelated($val) {
		$this->related = &$val;
	}
	
	function &getRelated() {
		return $this->related;
	}	
	
	
	function _callBack($property, $val) {
		if($property == 'date_posted' && !$val) {
			$val = date('Y-m-d H:i:s');
		
		} elseif($property == 'creator_id' && !$val) {
			$val = $_SESSION['auth_']['user_id'];
		
		} elseif($property == 'updater_id') {
			$val = $_SESSION['auth_']['user_id'];
		
		} elseif($property == 'active' && !$val) {
			$val = 0;
		}  		
		return $val;
	}
	
	
	function validate($values) {
		
		require_once 'jumper_lib/Validator.php';
		
		$required = array('title', 'body', 'category');
		
		$v =& new Validator($values, false);

		// check for required first, return errors
		$v->requiredArray('required_msg', $required);
		if($v->getErrors()) {
			$this->errors =& $v->getErrors();
			return true;
		}
	}
}
?>