<?php
//************************************************************************************
//** JMPEntrySender.php - Entry Sender Class
//** This file contains the entry sender function modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class JMPEntrySender extends JMPEntryModel
{
	
	function JMPEntrySender() {
		
		parent::JMPEntryModel;
				
		$this->controller = &new JumperController;
		$this->controller->mod_rewrite = false;
	}
	
	
	
	function getSubscribersSql($category_id) {
		$sql = "
		SELECT 
			u.*
		FROM 
			{$this->tbl->data_to_user_rule} d, 
			{$this->tbl->data_to_user_value} dv,
			{$this->tbl->user}
		WHERE 1
			AND d.title = 'jmp_category_to_admin'
			AND d.id = dv.rule_id
			AND dv.data_value IN ($category_id)
			AND dv.user_value = u.id";
			
		return $sql;
	}
	
	
	function &getCategories() { 
		$sql = "SELECT id, parent_id FROM {$this->tbl->category}";
		$result = &$this->db->Execute($sql) or die(db_error($sql));
		while($row = &$result->FetchRow()) {
			$data[$row['id']] = $row;
		}
		
		$data;
	}
	
	function &getParentCategories($id, $categories) {
		return TreeHelperUtil::getParentsById($categories, $id);
	}
	
	
	function getLetter($records) {
		
		$tpl = &new tplTemplatez(APP_EMAI_TMPL_DIR . 'updated_profiles.html');
		
		
		foreach($records['posted'] as $k => $v) {		
			
			$v['profile_link'] = $controller->getLink('entry', $v['category_id'], $v['id']);
			$v['body'] = $this->getSummary($v['body']);
			$v['date'] = strftime('%d %b, %Y', $v['posted_ts']); 
				
			$tpl->tplParse($v, 'row_posted');
		}
		
		$tpl->tplAssign($this->conf);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getSummary($str, $num_signs = '150') {
	
		if($num_signs == 'all') { return $str; }
		
		$values = array('<br>', '<BR>',  '< /br>', '<li>', '<p>', '<P>', '  ');
		$str = strip_tags(str_replace($values, ' ', $str)); 
		
		if(strlen($str) < $num_signs) { return $str; }
		
		return substr($str, 0, strrpos(substr($str, 0, $num_signs), ' ')) . '...';
	}
	
	
	function send() {
	
	
	}
}
?>