<?php
//************************************************************************************
//** JMPGlossaryView.php - Glossary View Class
//** This file contains the glossary view function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once 'jumper_lib/SQL/SearchParams.php';


class JMPGlossaryView_list extends AppView
{
	
	var $tmpl = 'list.html';
	
	
	function execute(&$obj, &$manager) {

		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		
		$search = &$this->searchForm();
		$manager->setSqlParams('AND '. $search['sql']);
		
		//letter filter
		$sql = $this->parseLetterFilter($tpl, $_GET);
		$manager->setSqlParams('AND ' . $sql);
		

		// header generate
		$bp =& $this->pageByPage($manager->limit, $manager->getRecordsSql());
		$tpl->tplAssign('header', $this->commonHeaderList($bp->nav, $search['form']));
		
		// sort generate
		$sort = &$this->getSort();
		$manager->setSqlParamsOrder($sort->getSql());
		
		// get records
		$rows =& $this->stripVars($manager->getRecords($bp->limit, $bp->offset));
		
		// alt phrases - not done
		//foreach($rows as $v) { $ids[] = $v['id']; }
		//$alt_phrases = &$manager->getAltPhrases(implode(',', $ids));
		
		
		// list records
		foreach($rows as $row) {
			
			$obj->set($row);
			$obj->set('display_once', ($obj->get('display_once') ? '<li>' : '-'));
			
			$tpl->tplAssign($this->getViewListVars($obj->get('id')));
			$tpl->tplParse(array_merge($obj->get(), $this->msg), 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($sort->toHtml());
	
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function &getSort() {
		//$sort = new TwoWaySort();
		$sort = new OneWaySort($_GET);
		$sort->default_order = 1;
		$sort->setTitleMsg('asc',  $this->msg['sort_asc_msg']);
		$sort->setTitleMsg('desc', $this->msg['sort_desc_msg']);
		$sort->setSortItem('phrase_msg',       'phrase', 'phrase', $this->msg['phrase_msg'], 1);
		$sort->setSortItem('definition_msg',   'definition', 'definition', $this->msg['definition_msg']);
		$sort->setSortItem('display_once_msg', 'once', 'display_once', $this->msg['display_once_msg']);
		
		//$sort->getSql();
		//$sort->toHtml()
		return $sort;
	}
	
	
	function searchForm() {
		
		$tpl = &new tplTemplatez($this->template_dir . 'search_form.html');
		$tpl->tplAssign('hidden_fields', $this->getHiddenFields($_GET, array('phrase', 'do_search')));
		
		// search
		$search = new SearchParams();
		$search->setFormSubmitField(@$_GET['do_search']);
		
		//$search->setFullTextSearch();
		//$search->setParams(@$_GET['phrase'], 'phrase', array('phrase', 'definition'));
		
		$val = $search->setLikeSql(@$_GET['phrase']);
		$search->setParams($val, 'phrase', 'phrase');
		
		
		$tpl->tplAssign('search_msg', $this->msg['search_world_msg']);
		$tpl->tplParse($_GET);
		
		//$form_var =& $search->getVars();
		$val = array();
		$val['form'] = $tpl->tplPrint(1);
		$val['sql']  = $search->getSQL();
		
		return $val;
	}
	
	
	function parseLetterFilter(&$tpl, $vars) {
			
		//letter filter
		$get = $vars;
		unset($get['letter']);
		$str = http_build_query($get);
		
		foreach(range('a', 'z') as $k => $v) {
			$a['letter'] = strtoupper($v);
			$a['letter_link'] = $_SERVER['PHP_SELF'] . '?' . $str . '&letter=' . $v;
			$a['letter_class'] = (@$vars['letter'] == $v) ? 'tdSubTitle' : '';
			
			$tpl->tplParse($a, 'letter');
		}
	
	
		$ar = $vars; unset($ar['letter']);
		$tpl->tplAssign('all_letter_link', $_SERVER['PHP_SELF'] . '?'. http_build_query($ar));
		//$tpl->tplAssign('all_letter_msg', 'value');
	
		
		if(isset($vars['letter'])) {
			$sql = "phrase LIKE '". $vars['letter'] . "%'";
		} else {
			$sql = '1';
		}
		
		return $sql;
	}
		
}
?>
