<?php
//************************************************************************************
//** JMPHomeView.php - Jumper Home Page View Class
//** This file contains the home page view function written by Evgen Leontev (c) 2005
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once APP_ROOT_DIR . 'modules/knowledgebase/entry/inc/JMPEntryModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/comment/inc/JMPCommentModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/category/inc/JMPCategoryModel.php';
require_once APP_ROOT_DIR . 'modules/knowledgebase/comment/inc/JMPCommentView_helper.php';


class JMPHomeView_default extends AppView
{
	
	var $num = 10;
	
	function execute() {
		
		$tpl = &new tplTemplatez($this->template_dir . 'page.html');
		
		//$tpl->tplAssign('most_viewed', $this->getMostViewedQuestions());
		$tpl->tplAssign('most_viewed', $this->getRecentProfiles());
		$tpl->tplAssign('recently_posted', $this->getRecentlyPostedComments());
		//$tpl->tplAssign('quick_link', $this->getQuickLinks());		
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getMostViewedQuestions() {
		
		$entry = &new JMPEntryModel;
		$entry->setSqlParamsOrder('ORDER BY hits DESC');
		
		$this->priv->setOwnParam($entry->getOwnParams($this->priv));
		$entry->setSqlParams('AND ' . $this->priv->getOwnParam('jmp_entry'));
		$rows = &$this->stripVars($entry->getRecords(10, 0));
		
		$tpl = &new tplTemplatez($this->template_dir . 'most_viewed.html');
		
		foreach($rows as $k => $v) {
			
			$more = array('id'=>$v['id']);
			$link =  $this->controller->getLink('knowledgebase', 'jmp_entry', false, 'update', $more);
			$v['entry_link'] = $link;
		
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getRecentProfiles() {
		
		$entry = &new JMPEntryModel;
		$entry->setSqlParamsOrder('ORDER BY date_posted DESC');
		
		$this->priv->setOwnParam($entry->getOwnParams($this->priv));
		$entry->setSqlParams('AND ' . $this->priv->getOwnParam('jmp_entry'));
		$rows = &$this->stripVars($entry->getRecords(10, 0));
		
		$tpl = &new tplTemplatez($this->template_dir . 'recent_profile.html');
		
		foreach($rows as $k => $v) {
			
			$more = array('id'=>$v['id']);
			$link =  $this->controller->getLink('knowledgebase', 'jmp_entry', false, 'update', $more);
			$v['entry_link'] = $link;
			$v['status_num'] = $v['active'] ? '1' : '0';
			$v['date'] = $this->getFormatedDate($v['ts']);
		
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getRecentlyPostedComments() {
		
		$entry = &new JMPCommentModel;
		$entry->setSqlParamsOrder('ORDER BY date_posted DESC');
		
		$this->priv->setOwnParam(sprintf('e.creator_id=%d', $this->priv->user_id));
		$entry->setSqlParams('AND ' . $this->priv->getOwnParam('jmp_entry'));
		$rows = &$this->stripVars($entry->getRecords(10, 0));
		
		//BB CODE
		$parser = &JMPCommentView_helper::getBBCodeObj();
		
		$tpl = &new tplTemplatez($this->template_dir . 'recent_comment.html');
		
		foreach($rows as $k => $v) {
		
			$more = array('id'=>$v['id']);
			$link =  $this->controller->getLink('knowledgebase', 'jmp_comment', false, 'update', $more);
			
			$v['entry_link'] = $link;
			$v['status_num'] = $v['active'] ? '1' : '0';
			$v['comment'] =  $parser->qparse($v['comment']);
			$v['date'] = $this->getFormatedDate($v['ts']);
			
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function getQuickLinks() {
	
		$this->addMsg('file_msg.ini');
	
		$tpl = &new tplTemplatez($this->template_dir . 'quick_link.html');
		
		$module = 'knowledgebase';
		$tpl->tplAssign('entry_link', $this->controller->getLink($module, 'jmp_entry', false, 'insert'));
		$tpl->tplAssign('category_link', $this->controller->getLink($module, 'jmp_category', false, 'insert'));	
		$tpl->tplAssign('glossary_link', $this->controller->getLink($module, 'jmp_glossary', false, 'insert'));			
		
		$module = 'file';
		$tpl->tplAssign('file_entry_link', $this->controller->getLink($module, 'file_entry', false, 'insert'));
		$tpl->tplAssign('file_category_link', $this->controller->getLink($module, 'file_category', false, 'insert'));			
		
		
		if($this->priv->isPriv('insert', 'jmp_entry')) {
			$tpl->tplSetNeeded('/add_entry');
		}
		
		if($this->priv->isPriv('insert', 'jmp_category')) {
			$tpl->tplSetNeeded('/add_entry_category');
		}
		
		if($this->priv->isPriv('insert', 'jmp_glossary')) {
			$tpl->tplSetNeeded('/add_glossary');
		}		
		
		if($this->priv->isPriv('insert', 'file_entry')) {
			$tpl->tplSetNeeded('/add_file');
		}		
		
		if($this->priv->isPriv('insert', 'file_category')) {
			$tpl->tplSetNeeded('/add_file_category');
		}		
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
}

/*
Total Questions: 69
Total Visible: 63 
Total Hidden: 6
Total Categories: 72
Total Root: 38 
Total Sub: 34
Total Glossary Words: 34 
Total Comments: 162
Total Approved: 150 
Total Disapproved: 12 
Total Pending: 0
*/

// Recently Posted Comments
?>
