<?php
//************************************************************************************
//** LetterTemplateModel.php - Letter Template Model Class
//** This file contains the letter template model function written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class LetterTemplateModel extends AppModel
{

	var $tbl_pref_custom = '';
	var $tables = array('table'=>'letter_template');


	function isPredifined($id) {
		$sql = "SELECT predifined FROM {$this->tbl->table} WHERE id = %d";
		$sql = sprintf($sql, $id);
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return $result->Fields('predifined');
	}
	
	
	function getById($id) {
		$data1 = parent::getById($id);
		$data2 = AppMailParser::getTemplateMsg($data1['letter_key']);
		return $this->getDataMerged($data1, $data2);
	}
	
	
	function getDataMerged($data1, $data2) {
		
		$data = array();
		foreach($data1 as $k => $v) {
			$data[$k] = $v;
			if(empty($v) && isset($data2[$k])) {
				$data[$k] = $data2[$k];
			}
		}
		
		return $data;
	}	
}
?>