<?php
//************************************************************************************
//** PageController.php - Member Page Controller Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

$controller->loadClass('Member');
$controller->loadClass('MemberModel');
$controller->loadClass('RoleModel', 'role');


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new Member;

$manager =& $obj->setManager(new MemberModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	$manager->delete($rq->id);
	$controller->go();
	
	break;
	

case 'status': // ------------------------------
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	

case 'insert': // ------------------------------
case 'update': // ------------------------------
	
	if(isset($rp->submit)) {
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);	
			$obj->set($rp->vars);
			
		} else {
			$rp->stripVars();
			
			$obj->setPassword($rp->not_change_pass); // mean not insert in db if not_change_pass = 1
			$obj->set($rp->vars);
			
			$manager->save($obj);
			
			$controller->go();
		}
		
	} elseif($controller->action == 'update') {
		
		$data = &$manager->getById($rq->id);
		$rp->stripVarsValues($data);
		$obj->set($data);		
	}

	$view = &$controller->getView($obj, $manager, 'MemberView_form');

	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'MemberView_list');
}
?>