<?php
//************************************************************************************
//** MemberModel.php - Member Model Class
//** This file contains the member model function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class MemberModel extends AppModel
{

	var $tbl_pref_custom = '';
	var $tables = array('table'=>'member', 'member', 'role');
	var $custom_tables = array('entry'=>'jmp_entry');
	
	
	function getRecordsSql() { 
		$sql = "
		SELECT 
			m.*, 
			r.title AS role, 
			UNIX_TIMESTAMP(date_registered) AS ts
		FROM {$this->tbl->member} m 
		LEFT JOIN {$this->tbl->role} r ON m.role_id = r.id
		WHERE {$this->sql_params}
		{$this->sql_params_order}";
		
		return $sql;
	}
	
	
	function getRolesSelectRange() {
		$r = new RoleModel;
		return $r->getSelectRange('member');
	}	
	
	
	function save(&$obj) {
		
		if(!$obj->get('id')) {
			$user_id = $this->add($obj);
			
		} else {
			$this->update($obj);
			$user_id = $obj->get('id');
		}
	}	

	// VALIDATING // -------------------------
	
	// return true if we already have such username false otherwise
	function isUsernameExists($username, $id = false) {
		
		$cond = ($id) ? "id != '$id'" : "1=1"; 
		
		$sql = "SELECT 1 FROM {$this->tbl->member} WHERE username = '$username' AND $cond";
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return (bool) ($result->Fields(1));
	}
	
	
	// return true if we already have such email false otherwise
	function isEmailExists($email, $id = false) {
		
		$cond = ($id) ? "email != '$email'" : "1=1";
		
		$sql = "SELECT 1 FROM {$this->tbl->member} WHERE email = '$email' AND $cond";
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		return (bool) ($result->Fields(1));
	}
	
	
	
	// DELETE RELATED // ---------------------
	
}
?>
