<?php
//************************************************************************************
//** PageController.php - Setting Page Controller Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once $controller->working_dir . 'inc/Setting.php';
require_once $controller->working_dir . 'inc/SettingModel.php';


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);
$rp->wordrap_num = 300;


$obj = new Setting;

$manager =& $obj->setManager(new SettingModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


$setting_ar = array('jmp_setting'	=> 'knowledgebase',
                    'file_setting'	=> 'file',
					'email_setting'	=> 'email_setting');
$manager->setModuleId($setting_ar[$controller->page]);


if(isset($rp->submit)) {
	
	if(APP_DEMO_MODE) { $controller->go('not_allowed_demo', true); }

	$parser = $manager->getParser();
	$rp->values = $parser->parseReplacementsArray($manager->formDataToObj($rp->values));
	
	$is_error =& $obj->validate($rp->values, $manager);	
	
	if($is_error) {
		$rp->stripVars(true);
		$obj->set($rp->values);
		
	} else {
		$rp->stripVars();
		$manager->save($rp->values);
		
		$controller->go();
	}

} elseif(isset($rp->set_default)) {
		
		if(APP_DEMO_MODE) { $controller->go('not_allowed_demo', true); }		
		
		$manager->setDefaultValues();
		$controller->go();

} else {
	
	$data = &$manager->getSettings();
	$rp->stripVarsValues($data);
	$obj->set($data);
}


$view = &$controller->getView($obj, $manager, 'SettingView_form');
?>