<?php
//************************************************************************************
//** PageController.php - User Page Controller Class
//** This file contains the page controller function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

require_once $controller->working_dir . 'inc/User.php';
require_once $controller->working_dir . 'inc/UserModel.php';


// initialize objects
$rq =& new RequestData($_GET);
$rp =& new RequestData($_POST);

$obj = new User;
$obj->is_admin = (isset($_SESSION['priv_']['all']));

$manager =& $obj->setManager(new UserModel());
$manager->checkPriv($priv, $controller->action, @$rq->id);


switch ($controller->action) {
case 'delete': // ------------------------------
	
	if(APP_DEMO_MODE) { $controller->go('not_allowed_demo', true); }
	
	$manager->delete($rq->id);
	$controller->go();
	
	break;
	

case 'status': // ------------------------------
	
	if(APP_DEMO_MODE) { $controller->go('not_allowed_demo', true); }
	
	$manager->status($rq->status, $rq->id);
	$controller->go();

	break;
	
	
case 'update': // ------------------------------
case 'insert': // ------------------------------
	
	if(isset($rp->submit)) {
		
		if(APP_DEMO_MODE) { $controller->go('not_allowed_demo', true); }
		
		$is_error =& $obj->validate($rp->vars, $manager);
		
		if($is_error) {
			$rp->stripVars(true);
			
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
		
		} else {
			$rp->stripVars();
			
			$obj->setPassword($rp->not_change_pass); // mean not insert in db if not_change_pass = 1
			$obj->set($rp->vars);
			$obj->setPriv(@$rp->vars['priv']);
			
			$manager->save($obj, AuthPriv::getUserId());
			$controller->go();
		}
	
	} elseif($controller->action == 'update') {
		
		$data = &$manager->getById($rq->id);
		$rp->stripVarsValues($data);
		$obj->set($data);
		
		$data = &$manager->getPrivById($rq->id);
		$rp->stripVarsValues($data);
		$obj->setPriv($data);		
	}
	
	$view = &$controller->getView($obj, $manager, 'UserView_form');

	break;


default: // ------------------------------------
	
	$view = &$controller->getView($obj, $manager, 'UserView_list');
}
?>