<?php
//************************************************************************************
//** UserView-form.php - User View Form Class
//** This file contains the user view form function written by Evgen Leontev (c) 2005 
//** and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//***********************************************************************************

class UserView_form extends AppView
{
	
	var $tmpl = 'form.html';
	var $account_view = false;

	
	function execute(&$obj, &$manager) {
		
		$this->addMsg('user_msg.ini');
		
		$tpl = &new tplTemplatez($this->template_dir . $this->tmpl);
		$tpl->tplAssign('error_msg', AppMsg::errorBox($obj->errors));
		
		// priv select
		if($obj->is_admin) {
			
			$priv_lang = AppMsg::getMsgs('privileges_msg.ini');
			
			$priv_data = $manager->getAllPriv();
			foreach($priv_data as $k => $v) {
				$priv_data[$k] = $priv_lang[$k]['name'];
			}
			
			$select = new FormSelect();
			$select->setSelectWidth(250);
			$select->setMultiple(5, false);
			$select->setSelectName('priv');
			$select->setRange($priv_data);
			
			$tpl->tplSetNeededGlobal('priv_box');
			$tpl->tplAssign('priv_select', $select->select($obj->getPriv()));
			
			
			foreach($priv_lang as $k => $v) {
				$v['description'] = nl2br($v['description']);
				$tpl->tplParse($v, 'priv_description');
			}
		}
		
		
		if($this->controller->getAction() == 'update') {
			$tpl->tplSetNeeded('/not_change_pass');
		}
		
		
		$val = ($_POST) ? $_POST['not_change_pass'] : 1;
		$tpl->tplAssign('pass_change_checked', $this->getChecked($val));
		
		if(!$this->account_view) {
			$tpl->tplSetNeededGlobal('account');
		}
		
		
		$tpl->tplAssign($this->setCommonFormVars($obj));
		$tpl->tplAssign($this->setStatusFormVars($obj->get('active')));
		$tpl->tplAssign($obj->get());
		$tpl->tplAssign($this->msg);
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
}
?>