﻿//************************************************************************************
//** fckicon.js - FCKEditor Class for Rendering Icons
//** This file renders an icon from a single image, a strip or even a spacer written  	
//** by Frederico Caldeira Knabben (c) 2003-2006 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

var FCKIcon = function( iconPathOrStripInfoArray )
{
	var sTypeOf = iconPathOrStripInfoArray ? typeof( iconPathOrStripInfoArray ) : 'undefined' ;
	switch ( sTypeOf )
	{
		case 'number' :
			this.Path = FCKConfig.SkinPath + 'fck_strip.gif' ;
			this.Size = 16 ;
			this.Position = iconPathOrStripInfoArray ;
			break ;
		
		case 'undefined' :
			this.Path = FCK_SPACER_PATH ;
			break ;
		
		case 'string' :
			this.Path = iconPathOrStripInfoArray ;
			break ;
		
		default :
			// It is an array in the format [ StripFilePath, IconSize, IconPosition ]
			this.Path		= iconPathOrStripInfoArray[0] ;
			this.Size		= iconPathOrStripInfoArray[1] ;
			this.Position	= iconPathOrStripInfoArray[2] ;
	}
}

FCKIcon.prototype.CreateIconElement = function( document )
{
	var eIcon ;
	
	if ( this.Position )		// It is using an icons strip image.
	{
		var sPos = '-' + ( ( this.Position - 1 ) * this.Size ) + 'px' ;
	
		if ( FCKBrowserInfo.IsIE )
		{
			// <div class="TB_Button_Image"><img src="strip.gif" style="top:-16px"></div>
			
			eIcon = document.createElement( 'DIV' ) ;
			
			var eIconImage = eIcon.appendChild( document.createElement( 'IMG' ) ) ;
			eIconImage.src = this.Path ;
			eIconImage.style.top = sPos ;
		}
		else
		{
			// <img class="TB_Button_Image" src="spacer.gif" style="background-position: 0px -16px;background-image: url(strip.gif);">
			
			eIcon = document.createElement( 'IMG' ) ;
			eIcon.src = FCK_SPACER_PATH ;
			eIcon.style.backgroundPosition	= '0px ' + sPos ;
			eIcon.style.backgroundImage		= 'url(' + this.Path + ')' ;
		}
	}
	else					// It is using a single icon image.
	{
		// This is not working well with IE. See notes bellow.
		// <img class="TB_Button_Image" src="smiley.gif">
//		eIcon = document.createElement( 'IMG' ) ;
//		eIcon.src = this.Path ? this.Path : FCK_SPACER_PATH ;

		// IE makes the button 1px higher if using the <img> directly, so we
		// are changing to the <div> system to clip the image correctly.
		eIcon = document.createElement( 'DIV' ) ;
		
		var eIconImage = eIcon.appendChild( document.createElement( 'IMG' ) ) ;
		eIconImage.src = this.Path ? this.Path : FCK_SPACER_PATH ;
	}
	
	eIcon.className = 'TB_Button_Image' ;

	return eIcon ;
}