<?php
//**********************************************************************************
//** create_rss.php - Knowledgebase RSS
//** This file contains the Knowledgebase RSS Feed written by Evgen Leontev (c) 
//** 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

$app_dir = str_replace(array('\\', '/client/cron/'), '/', getcwd() . '/');

$admin_dir  = $app_dir . 'admin/';
$client_dir = $app_dir . 'client/inc/';
$cron_dir   = $app_dir . 'client/cron/';

$filename   = $app_dir . 'jmp.rss';


require_once $admin_dir . 'config.inc.php';

if(!isset($_SERVER['DOCUMENT_ROOT'])) {
	echo 'You should manually specify $_SERVER["DOCUMENT_ROOT"] in admin/config.inc.php' . "\n";
}


require_once $cron_dir . 'cron_common.php';
require_once 'jumper/XML/RSSCreator.php';

require_once $client_dir . 'JumperController.php';
require_once $client_dir . 'JumperRSSModel.php';
require_once $client_dir . 'DocumentParser.php';


$manager = &new JumperRSSModel();
$setting =&$manager->getSettings();
$entries = &$manager->getEntries();

if($entries) {

	$controller = &new JumperController();
	$controller->jmp_path = APP_CLIENT_PATH;
	$controller->setModRewrite(false);

	$rss = &new RSSCreator();
	$rss->setEncoding($conf['lang']['meta_charset']);
	$rss->setChannel('title', $setting['rss_title']);
	$rss->setChannel('link', APP_CLIENT_PATH);
	$rss->setChannel('description', $setting['rss_description']);
	
	foreach($entries as $k => $v) {
		$link = $controller->getLink('entry', $v['category_id'], $v['entry_id']);
		$rss->setItem($v['title'], $link, $v);
	}
	echo "<pre>"; print_r($filename); echo "</pre>";
	FileUtil::write($filename, $rss->getXML());
	//echo $rss->getXML(true);
}


?>