<?php
//**********************************************************************************
//** JumperAction.php - Client Action
//** This file contains the client action modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction
{

	function JumperAction() {
		
	}
	
	
	function setVars(&$controller, $manager) {
		
		$this->rq = &new RequestData($_GET);
		$this->rp = &new RequestData($_POST);
		
		$this->entry_id    = &$controller->entry_id;
		$this->category_id = &$controller->category_id;
		$this->view_id     = &$controller->view_id;
		$this->msg_id      = &$controller->msg_id;
		
		
		if(!$this->entry_id) {
			$_SESSION['jmp_category_id_'] = false;
		}
		
		// set category session, probably this category will be browsing
		if($this->category_id) {
			$_SESSION['jmp_category_id_'] = $this->category_id;
		}
		
		if($this->entry_id) {
			$category_ids = $manager->getCategoryIdsByEntryId($this->entry_id);
			
			// no category in session trying to guess entry category
			if(empty($_SESSION['jmp_category_id_'])) {
				$_SESSION['jmp_category_id_'] = current($category_ids);
				//echo "<pre>"; print_r('Set Category: empty session'); echo "</pre>";
			
			// category not in session do the same as no session
			} elseif(!in_array($_SESSION['jmp_category_id_'], $category_ids)) {
				$_SESSION['jmp_category_id_'] = current($category_ids);
				//echo "<pre>"; print_r('Set Category: not in arary'); echo "</pre>";
			}
			
			//echo "<pre>"; print_r($category_ids); echo "</pre>";
			//echo "<pre>"; print_r($manager->categories); echo "</pre>";
		}
			
		
		$this->category_id = $_SESSION['jmp_category_id_'];
	}
	
	
	function checkAuth($controller, $manager) {
	
		// do auth by cookie if set
		if(AuthMember::getCookie() && !AuthMember::isAuth() && $manager->use_registration) {
			$auth = new AuthMember;
			$auth->setTable($manager->tbl->user);
			$auth->doAuthByCookie();
			$controller->go('all');
		}
		
		// check for inactivity time
		$auth_ended = false;
		if(!AuthMember::getCookie() && AuthMember::isAuth()) {
			AuthMember::spentTime($manager->getSetting('auth_expired'));
			if(!AuthMember::isAuth()) {
				$auth_ended = true;
				$manager->user_id = false;
				$manager->user_role_id = false;
				$manager->is_registered = false;
				$manager->setCategories();
			}
		}
		
		// registered only
		if(!$manager->is_registered && $manager->getSetting('jmp_register_access')) {
			$not_private = array('register', 'login', 'password', 'confirm', 'success_go');
			if(!in_array($this->view_id, $not_private)) {
				$login_msg = ($auth_ended) ? 'authtime_enter' : 'enter';
				$controller->go('login', '', '', $login_msg);
			}
		}
		
		
		// check private
		$private_views = array('entry', 'comment', 'print', 'getfile', 'index');
		if(in_array($this->view_id, $private_views) && $this->msg_id != 'glossary' ) {
			
			$private = ($this->category_id) ? $manager->isPrivateCategory($this->category_id) : false;
			
			// category hidden  = for some role or private_policy = 1 (hidden)
			// user should not see this category at all
			if($private == 'hidden') {
				if($auth_ended) { $controller->go('login', $this->category_id, $this->entry_id, 'authtime_' . $this->view_id); } 
				else            { $controller->go(); }
				
			// display msg if private category and $auth_ended
			// if we see concrete profile, not category listing
			} elseif($private == 'display' && $this->view_id != 'index') {
				$login_msg = ($auth_ended) ? 'authtime_' . $this->view_id : 'entry';
				$controller->go('login', $this->category_id, $this->entry_id, $login_msg);
			
			// if concrete profile private (not category)
			// if user tries to see it they will see an empty screen (not good)
			// does not matter for role or not
			// we need to determine other options here...
			} elseif(!$manager->is_registered && $this->entry_id) {
				if($manager->isPrivateEntry($this->entry_id)) {
					$login_msg = ($auth_ended) ? 'authtime_' . $this->view_id : 'entry';
					$controller->go('login', $this->category_id, $this->entry_id, $login_msg);
				}
			}
		}
	}
}
?>