<?php
//**********************************************************************************
//** JumperController.php - Client Controller
//** This file contains the client controller written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperController
{
	var $query 		= array('view'        =>'View',
                            'category_id' =>'CategoryID',
				  	        'entry_id'    =>'EntryID',
					        'msg'  		  =>'Msg'
				   		    );
	
	var $request;
	
	var $working_dir;
	var $working_path;	
	var $mod_rewrite = false;
	var $jmp_path;
	var $client_path;
	var $setting = array();
	
	var $extra_params = array();
	var $dirs = array();
	var $arg_separator = '&amp;';
	
	
	function JumperController() {
		$this->setUrlVars();
	}
	
	
	function setDirVars(&$settings) {
	
		$client_dir = APP_CLIENT_DIR . 'client/inc/';
	
		$this->jmp_path     = APP_CLIENT_PATH;
		$this->jmp_dir      = APP_CLIENT_DIR;
		$this->client_path = APP_CLIENT_PATH . 'client/';
		$this->skin_dir    = APP_CLIENT_DIR . 'client/skin/';
		$this->skin_path   = APP_CLIENT_PATH . 'client/skin/';
		
		$this->common_dir          = $client_dir;
		$this->default_working_dir = $client_dir . 'default/';
		$this->working_dir         = $client_dir . $settings['view_format'] . '/';

		$this->setting = &$settings;		
	}
	
	
	function setUrlVars() {
		
		//$this->category_key = $this->getRequestVar('category_id');		
		$this->category_id = (int) $this->getRequestVar('category_id');

		//$this->entry_key = $this->getRequestKey('entry_id');
		$this->entry_id = (int) $this->getRequestVar('entry_id');
		
		$this->view_key = $this->getRequestKey('view');
		$view_id = $this->getRequestVar('view');
		$this->view_id = ($view_id) ? $view_id : 'index';
		
		//$this->msg_key = $this->getRequestKey('msg');
		$this->msg_id = $this->getRequestVar('msg');		
	}
	
	
	function setSettings(&$settings) {
		$this->setting = &$settings;
	}
	
	
	function getSetting($setting_key) {
		return @$this->setting[$setting_key];
	}
	
	
	function setModRewrite($var) {
		$this->mod_rewrite = $var;
	}
	
	
	function getRequestVar($var) {
		return @$_GET[$this->query[$var]];
	}
	
	
	function getRequestKey($key) {
		return @$this->query[$key];
	}
	
	
	function go($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		$this->arg_separator = '&';
		ini_set('arg_separator.output', $this->arg_separator);
		$url = $this->getLink($view, $category_id, $entry_id, $msg_key);
		header("Linked Data: " . $url);
		exit();
	}	
	
	
	function getLink($view = false, $category_id = false, $entry_id = false, $msg_key = false) {
		if($view == 'all') {
			return $this->_getLink($this->view_id, 
			                       $this->category_id,
								   $this->entry_id, 
								   $this->msg_id); 	
		} else {
			return $this->_getLink($view, $category_id, $entry_id, $msg_key);
		}
	}
		
	
	function _getLink($view = 'index', $category_id = false, $entry_id = false, $msg_key = false) {
		
		$link = array();
		$category_id = ($view == 'index' || $view == 'file') ? $category_id : false;
		$view = ($view == 'index') ? false : $view;
		
		if(!$this->mod_rewrite) {
		
			if($view)        { $link[1] = sprintf('%s=%s', $this->getRequestKey('view'), $view); }
			if($category_id) { $link[2] = sprintf('%s=%d', $this->getRequestKey('category_id'), $category_id); }
			if($entry_id)    { $link[3] = sprintf('%s=%d', $this->getRequestKey('entry_id'), $entry_id); }
			if($msg_key)     { $link[4] = sprintf('%s=%s', $this->getRequestKey('msg'), $msg_key); }
			if($this->extra_params) { $link[5] = http_build_query($this->extra_params); }
			
			$link = (!$link) ? $this->jmp_path : $this->jmp_path . '?' . implode($this->arg_separator, $link);
		
		} else {
		
			if($view)        { $link[1] = sprintf('%s', $view); }
			if($category_id) { $link[2] = sprintf('%d', $category_id); }
			if($entry_id)    { $link[3] = sprintf('%d', $entry_id); }
			if($msg_key)     { $link[4] = sprintf('%s', $msg_key); }
			
			$link = (@!$link) ? $this->jmp_path : $this->jmp_path . implode('/', $link) . '/';
		}
		
		return $link;
	}
	
	
	function getView($view_id = false) {
		
		if(!$view_id){
			$view_id = $this->view_id;
		}
		
		$class = 'JumperView_'. $view_id;
		
		$files = array();
		$files[]  = $this->working_dir . 'view/' . $class . '.php';
		$files[]  = $this->default_working_dir . 'view/' . $class . '.php';
		
		foreach($files as $file) {
			if(file_exists($file)) {
				require_once $file;
				return new $class;
			}			
		}
		
		
		$this->go();
		//require_once $this->default_working_dir . 'view/JumperView_404.php';
		//return new JumperView_404;
 	}
	
	
/*
	function &getAction($view_id = false) {
		
		if(!$view_id && !$this->getRequestVar('view')) {
			$view_id = 'index';
		} elseif(!$view_id){
			$view_id = $this->getRequestVar('view');
		}
		
		$class = 'JumperAction_'. $view_id;
		require_once $this->working_dir . 'action/' . $class . '.php';
		
		return new $class;
 	}
*/
}
?>