<?php
//**********************************************************************************
//** JumperLoader.php - Client Loader
//** This file contains the client loader written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperLoader
{

	function &getManager($controller, $setting) {
		
		$file_views = array('files', 'getfile');
		@$view = $_GET['View'];
		
		require_once $controller->working_dir . 'JumperModel_common.php';
		
		if(in_array($view, $file_views)) {
					
			require_once APP_EXTRA_MODULE_DIR . 'file/client/inc/JumperFileModel.php';
			require_once APP_EXTRA_MODULE_DIR . 'file/client/inc/JumperFileView.php';
			require_once APP_EXTRA_MODULE_DIR . 'file/client/inc/default/JumperFileModel_common.php';
			require_once APP_EXTRA_MODULE_DIR . 'file/client/inc/default/JumperFileView_common.php';
			
			$manager = &new JumperFileModel_common;
			$manager->setting = array_merge($setting, JumperModel::getSettings(200));
			$manager->setCustomSettings();
			
		} else {
		
			$manager = &new JumperModel_common;
			$manager->setting = &$setting;
			$manager->setCustomSettings();
		}
		
		$manager->is_registered = AuthMember::isAuth();
		$manager->user_id = AuthMember::getUserId();
		$manager->user_role_id = AuthMember::getRoleId();
		$manager->setCategories();
		$manager->use_registration = $manager->isUseRegistration();
		//echo "<pre>"; print_r($manager->setting); echo "</pre>";		
		//echo "<pre>"; print_r($manager->categories); echo "</pre>";	
		
		return $manager;
	}


	function &getView(&$controller, $manager) {
				
		require_once $controller->working_dir . 'JumperView_common.php';
		require_once $controller->working_dir . 'JumperAction_common.php';
		
		
		$actions = array('entry', 'glossary', 'comment', 'contact', 'send', 'search', 
						 'register', 'member', 'confirm', 'login', 'logout', 'password',
						 'success_go', 'print', 'file');
		
		//$suffics = ($view_id) ? $view_id : 'index';
		$suffics = (in_array($controller->view_id, $actions)) ?  $controller->view_id : 'default';
		$action_class = 'JumperAction_' . $suffics;
		$action_file  = 'JumperAction_' . $suffics . '.php';
		
		$file = $controller->working_dir . 'action/' . $action_file;
		if(!file_exists($file)) {
			$file = $controller->default_working_dir . 'action/' . $action_file;
		}
		
		require_once($file);
		
		$action = &new $action_class;
		$action->setVars($controller, $manager);
		$action->checkAuth($controller, $manager);
		return $action->execute($controller, $manager);
 	}
}
?>