<?php
//**********************************************************************************
//** JumperMailSender.php - Client Mail Sender
//** This file contains the client mail sender written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

require_once 'core/app/AppMailSender.php';


class JumperMailSender extends AppMailSender
{
	
	// to support about new user question
	function sendContactNotification($vars) {

		$this->letter_key = 'contact';

		// parser
		$parser = &$this->parser;
		$parser->assign($vars);
		
		// mail object
		$mail = &$this->getMailerObj($this->getTemplateVars(), $vars);
		$mail->From = $vars['email'];
		$mail->FromName = '';
		
		if(!empty($vars['attachment'])) {
			foreach($vars['attachment'] as $file) {
				$filename = basename($file);	
				$mail->AddAttachment($file, $filename);  // optional name
			}
		}
		
		$mail->Body = &$parser->parse($this->getTemplate());
		
		//echo "<pre>"; print_r($mail); echo "</pre>";
		//exit();
		
		return $mail->Send();
	}
	
	
	function sendToFriend($vars) {
		
		$this->letter_key = 'send_to_friend';

		// parser
		$parser = &$this->parser;
		$parser->assign($vars);
		$parser->assign('link', $vars['entry_link']);
		$parser->assign('message', $vars['comment']);
		
		// mail object
		$mail = &$this->getMailerObj($this->getTemplateVars());
		$mail->From = $vars['your_email'];
		$mail->FromName = $vars['name'];
		
		$mail->ClearAddresses();
		$mail->AddAddress($vars['friend_email']);
		
		$mail->Body = &$parser->parse($this->getTemplate());
		
		//echo "<pre>"; print_r($mail); echo "</pre>";
		//exit();
		
		return $mail->Send();
	}
	
	
	function sendConfirmRegistration($vars) {
		
		$this->letter_key = 'confirm_registration';

		// parser
		$parser = &$this->parser;
		$parser->assign($vars);
		$parser->assign('login', $vars['username']);
		$parser->assign('password', $vars['password']);
		
		// mail object
		$mail = &$this->getMailerObj($this->getTemplateVars());
		$mail->From = $this->noreply_email;
		$mail->FromName = $this->from_mailer;
		
		$mail->ClearAddresses();
		$mail->AddAddress($vars['email']);
		
		$mail->Body = &$parser->parse($this->getTemplate());
		
		//echo "<pre>"; print_r($mail); echo "</pre>"; 
		//exit();	
		
		return $mail->Send();		
	}
	
	
	function sendGeneratedPassword($vars) {
		
		$this->letter_key = 'generated_password';

		// parser
		$parser = &$this->parser;
		$parser->assign($vars);
		$parser->assign('name', $vars['first_name'] . ' ' . $vars['last_name']);
		$parser->assign('login', $vars['username']);
		
		
		// mail object
		$mail = &$this->getMailerObj($this->getTemplateVars());
		$mail->From = $this->noreply_email;
		$mail->FromName = $this->from_mailer;
		
		$mail->ClearAddresses();
		$mail->AddAddress($vars['email']);
		
		$mail->Body = &$parser->parse($this->getTemplate());
		
		//echo "<pre>"; print_r($mail); echo "</pre>"; 
		//exit();	
		
		return $mail->Send();
	}
}
?>