<?php
//**********************************************************************************
//** JumperSearchModel.php - Client Search Interface
//** This file contains the client search interface written by Evgen Leontev (c) 
//** 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperSearchModel extends JumperModel
{	

	var $sql_params_group;
	
		
	function getEntriesSql($body_words = 70) {
		
		$sql = "
		SELECT 
			e.*,
			SUBSTRING_INDEX(e.body,' ',70) AS body, 
			cat.id AS category_id,
			cat.name AS category_name,
			cat.private AS category_private,			
			UNIX_TIMESTAMP(e.date_posted) AS ts_posted,
			UNIX_TIMESTAMP(e.date_updated) AS ts_updated,
			{$this->sql_params_select}
		
		FROM 
			({$this->tbl->entry} e, 
			{$this->tbl->category} cat,
			{$this->tbl->entry_to_category} e_to_cat
			{$this->sql_params_from})
			
		LEFT JOIN {$this->tbl->data_to_value} du ON e.id = du.data_value 
		                                        AND du.rule_id = '{$this->entry_member_role_rule}'
			
		WHERE 1
			AND e.id = e_to_cat.entry_id
			AND cat.id = e_to_cat.category_id
			AND e.active = 1
			AND cat.active = 1
			AND IF(du.user_value, du.user_value = '{$this->user_role_id}', 1)
			AND {$this->sql_params}
		{$this->sql_params_group}	
		{$this->sql_params_order}";
		
		//echo "<pre>"; print_r($sql); echo "</pre>";
		return $sql;
	}
	
	
	function &getEntryList($limit, $offset, $body_words = 100) {	

		$sql = $this->getEntriesSql($body_words);
		$result =& $this->db->SelectLimit($sql, $limit, $offset) or die(db_error($sql));
		return $result->GetArray();
	}	
}
?>