<?php
//**********************************************************************************
//** JumperAction_comment.php - Client Action Comment
//** This file contains the client action comment written by Evgen Leontev
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_comment extends JumperAction_common
{

	function &execute($controller, $manager) {
	
		// need to login
		if(!$manager->is_registered && $manager->getSetting('allow_comments') == 2) { 
			$controller->go('login', $this->category_id, $this->entry_id, 'comment');
		}
		
		// if not allowed
		if(!$manager->getSetting('allow_comments')) {
			$controller->go('entry', $this->category_id, $this->entry_id);
		}
		
		
		$view = &$controller->getView();
	
		if(isset($this->rp->submit)) {
			
			$errors = $view->validate($this->rp->vars, $manager);
			//$flood = $manager->isFlood();
			
			if($errors) {
				$this->rp->stripVars(true);
				$view->setErrors($errors); 
				$view->setFormData($this->rp->vars);
			
			//} elseif($flood) {
			//	$this->rp->stripVars(true);
			//	$view->setFormData($this->rp->vars);
			//	$view->msg_id = 'flood_comment';
			
			} else {
				
				if($manager->is_registered) {
					$msg = ($manager->getSetting('comment_policy') != 2) ? 'comment_posted' : 'comment_wait';
					$active = ($manager->getSetting('comment_policy') != 2) ? 1 : 0;
				} else {
					$msg = ($manager->getSetting('comment_policy') == 1) ? 'comment_posted' : 'comment_wait';
					$active = ($manager->getSetting('comment_policy') == 1) ? 1 : 0;
				}
				
				$this->rp->stripVars();
				$manager->addComment($this->entry_id, $this->rp->vars, $active);
				$controller->go('success_go', $this->category_id, $this->entry_id, $msg);
			}
		}
		
		return $view;
	}
	
}
?>