<?php
//**********************************************************************************
//** JumperAction_contact.php - Client Action Contact
//** This file contains the client action contact written by Evgen Leontev
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_contact extends JumperAction_common
{

	function &execute($controller, $manager) {
		
		// not allowed
		if(!$manager->getSetting('allow_contact')) {
			$controller->go();
		}
		
		// need to login
		if(!$manager->is_registered && $manager->getSetting('allow_contact') == 2) { 
			$controller->go('login', $this->category_id, $this->entry_id, 'contact'); 
		}
	
		// attachment
		if($manager->getSetting('contact_attachment')) {
			$file_settings = &SettingModel::getQuick('200');
			$this->attachment_dir = $file_settings['file_dir'] . 'contact_attachment/';
			$this->attachment_max_filesize = ini_get('upload_max_filesize')*1024;
			//$this->attachment_max_filesize = 15;
		}
		

		$view = &$controller->getView();
				
		if(isset($this->rp->submit)) {
			
			$errors = $view->validate($this->rp->vars, $manager);
			//$flood = $manager->isFlood();
				
			if($errors) {
			
				$this->rp->stripVars(true);
				$view->setErrors($errors);
				$view->setFormData($this->rp->vars);
			
			//} elseif($flood) {
			
			//	$rp->stripVars(true);
			//	$view->setFormData($rp->vars);
			//	$view->msg_id = 'flood_comment';
			
			} else {
			
				// with file
				$files = array();
				if(!empty($_FILES['file_1']['name']) && $manager->getSetting('contact_attachment')) {
					
					$upload = &$this->upload();
					//echo "<pre>"; print_r($upload); echo "</pre>";
					//exit;
	
					if(!empty($upload['error_msg'])) {
						$errors['formatted'] = $upload['error_msg'];
						$view->setErrors($errors);
						$view->setFormData($this->rp->vars);
					
					} else {
						foreach($upload['good'] as $k => $v) {
							$files[] = $this->attachment_dir . $v['name'];
						}
					}
				}
				
				
				if(!$errors) {
				
					$this->rp->stripVars('stripslashes');
					$this->rp->vars['attachment'] = $files;
					$sent = $manager->sendContactNotification($this->rp->vars, $view);
					
					if($sent) {
						$this->rp->stripVars('addslashes');
						$this->rp->vars['attachment'] = implode(';', $files);
						$manager->addContactMessage($this->rp->vars);	
						$controller->go('success_go', $this->category_id, $this->entry_id, 'entry_sent');
					
					} else {
						$this->removeUploaded($files);
						
						$this->rp->stripVars(true);
						$view->setFormData($this->rp->vars);
						$view->msg_id = 'entry_not_sent';
					}
				}		
			}
		}
		
		return $view;
	}
	
	
	function upload() {
			
		require_once 'jumper_lib/Dir/Uploader.php';
	
		$upload = new Uploader;
		$upload->store_in_db = false;
		$upload->safe_name = true;
		$upload->setRenameValues('date');
		//$upload->setAllowedExtension($this->setting['file_allowed_extensions']);
		//$upload->setDeniedExtension($this->setting['file_denied_extensions']);
		$upload->setMaxSize($this->attachment_max_filesize);
		$upload->setUploadedDir($this->attachment_dir);
		
		$f = $upload->upload($_FILES);
	
		if(isset($f['bad'])) {
			$f['error_msg'] = $upload->errorBox($f['bad']);
		}

		return $f;
	}
	
	
	function removeUploaded($files) {
		foreach($files as $file) {
			unlink($file);
		}
	}
}


/*
Array
(
    [good] => Array
        (
            [1] => Array
                (
                    [name] => P1030080_s.jpg
                    [type] => image/jpeg
                    [tmp_name] => C:\DOCUME~1\APACHE~2\LOCALS~1\Temp\php371.tmp
                    [error] => 0
                    [size] => 0
                    [extension] => jpg
                )

        )

)
*/
?>