<?php
//**********************************************************************************
//** JumperAction_login.php - Client Action Login
//** This file contains the client action login written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_login extends JumperAction_common
{

	function &execute($controller, $manager) {
	
		// check if registration is not required
		if(!$manager->use_registration) {
			$controller->go();
		}
		
		$view = &$controller->getView('login');

		
		$msg_id = $view->msg_id;
		$view->msg_id = false;
		if(!isset($this->rp->submit)) {
			$authtime = (strpos($msg_id, 'authtime') !== false);
			if(in_array($msg_id, array_keys($view->login_msg)) || $authtime) {
				$msg_id_1 = ($authtime) ? 'authtime' : $msg_id;
				$view->msg_id = $view->login_msg[$msg_id_1];
			}	
		}		
		
		if(isset($this->rp->submit)) {
			
			$errors = $view->validate($this->rp->vars, $manager);
			
			if($errors) {
				$this->rp->stripVars(true);
				$view->setErrors($errors);
				$view->setFormData($this->rp->vars);
			
			} else {
				$view_id = str_replace(array('authtime_', 'category', '_'), '', $msg_id);
				$controller->go($view_id, $this->category_id, $this->entry_id);
			}
		}
		
		return $view;
	}
	
}
?>