<?php
//**********************************************************************************
//** JumperAction_password.php - Client Action Password
//** This file contains the client action password written by Evgen Leontevm 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_password extends JumperAction_common
{

	function &execute($controller, $manager) {
		
		//require_once $dir . 'JumperView_password.php';
		//$view = &new JumperView_password($controller);
		$view = &$controller->getView();
		
		if(isset($this->rp->submit)) {
			
			$pass = new PasswordUtil;
			$pass->table = $manager->tbl->user;	
			
			$v =& new Validator($this->rp->vars, false);
			$v->regex('email_msg', 'email', 'email');
		
			$user_id = $pass->isEmailExists($this->rp->vars['email']);
			if(!$user_id) { $v->setError('email_not_exists_msg', '1'); } 
			
			if($v->getErrors()) {
				$this->rp->stripVars(true);
				$view->setErrors($v->getErrors());
				$view->setFormData($this->rp->vars);
			
			} else {
				$user = $manager->getUserInfo($user_id);
				$password = $pass->generatePassword();
				$sent = $manager->sendGeneratedPassword($password, $user, $view);
				
				if($sent) {
					$this->rp->stripVars();
					$pass->setPassword($user_id, MD5($password));
					$controller->go('success_go', false, false, 'password_sent');
				
				} else {
					$this->rp->stripVars(true);
					$view->setFormData($this->rp->vars);
					$view->msg_id = 'password_not_sent';
				}
			}
		}
		
		return $view;
	}
	
}
?>