<?php
//**********************************************************************************
//** JumperAction_register.php - Client Action Register
//** This file contains the client action register written by Evgen Leontev 
//** (c) 2005 and modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_register extends JumperAction_common
{

	function &execute($controller, $manager) {
		
		// check if registration is not required
		if(!$manager->use_registration) {
			$controller->go();
		}	
		
		// check if registered
		$allow_register = $manager->getSetting('register_policy');
		if($manager->is_registered ||  !$allow_register) { 
			$controller->go();
		}
		
		
		$view = &$controller->getView('register');
		$view->update = false;
		
		$manager_1 = new MemberModel;
		
		if(isset($this->rp->submit)) {
			
			$errors = $view->validate($this->rp->vars, $manager, $manager_1);
			
			if($errors) {
				$this->rp->stripVars(true);
				$view->setErrors($errors);
				$view->setFormData($this->rp->vars);
			
			} else {
				
				$this->rp->stripVars('stripslashes');
				$sent = $manager->sendConfirmRegistration($this->rp->vars, $view);
				
				if($sent) {
				
					$this->rp->stripVars('addslashes');
					$view->obj->set($this->rp->vars);
				
					$view->obj->set('id', NULL);
					$view->obj->set('active', 0);
					$manager_1->save($view->obj);
					$controller->go('success_go', false, false, 'confirmation_sent');
				
				} else {
					$this->rp->stripVars(true);
					$view->setFormData($this->rp->vars);
					$view->msg_id = 'confirmation_not_sent';
				}
			}
		}
		
		return $view;
	}
	
}
?>