<?php
//**********************************************************************************
//** JumperAction_send.php - Client Action Send
//** This file contains the client action send written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperAction_send extends JumperAction_common
{

	function &execute($controller, $manager) {
		
		$view = &$controller->getView();
		
		if(isset($this->rp->submit)) {
			
			$errors = $view->validate($this->rp->vars);	
	
			if($errors) {
				$this->rp->stripVars(true);
				$view->setErrors($errors);
				$view->setFormData($this->rp->vars);
			
			} else {
				
				$this->rp->setHtmlValues('entry_link');
				$this->rp->stripVars('stripslashes');
				
				$sent = $manager->sendToFriend($this->rp->vars);
				
				if($sent) {
					$controller->go('success_go', $this->category_id, $this->entry_id, 'friend_sent');
				
				} else {
					$this->rp->stripVars(true);
					$view->setFormData($this->rp->vars);
					$view->msg_id = 'entry_not_sent';
				}
			}
		}
			
		return $view;
	}
}
?>