<?php
//**********************************************************************************
//** JumperView_comment.php - Client View Comment
//** This file contains the client view comment written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

require_once 'jumper_lib/Util/CryptEmail.php';


class JumperView_comment extends JumperView_common
{

	function &execute(&$manager) {
		
		$row = &$manager->getEntryById($this->entry_id, $this->category_id);
		$row = &$this->stripVars($row);
		if(!$row) { return; }
		
		$this->meta_title = $this->msg['add_comment_msg'];
		$title = ''; //($this->controller->getSetting('show_title_nav')) ? $row['title'] : '';
		
		$data = $this->getTop($manager, $title, false);
		$data .= $this->getForm($manager);
		$data .= $this->getEntry($manager, $row);
		
		return $data;		
	}
	
	
	function getEntry(&$manager, &$row)  {
		$tpl = &new tplTemplatez($this->template_dir . 'profile.html');
		$tpl->tplParse(array_merge($row, $this->msg));
		return $tpl->tplPrint(1);
	}
	
 
	function getForm($manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'comment_form.html');
		
		$tpl->tplSetNeeded('/cancel_btn');
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink('entry', $this->category_id, $this->entry_id));															  
		
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		if(!$manager->is_registered) {
			$tpl->tplSetNeeded('/not_registered');
		}
		
		if($this->useCaptcha($manager, 'comment')) {
			$tpl->tplSetNeeded('/captcha');
			$tpl->tplAssign('captcha_src', $this->getCaptchaSrc());
		}
		
		$tpl->tplAssign('toggle_form', 0);
		$tpl->tplAssign('display_form', 'block');
		
		$tpl->tplAssign('jmp_path', $this->controller->jmp_path);
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($this->getFormData());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values, $manager) {
		
		require_once 'jumper_lib/Validator.php';
		
		$v =& new Validator($values, false);
		$v->requiredArray('required_msg', array('comment'));
		
		if(isset($values['email'])) {
			$v->regex('email_msg', 'email', 'email', false);
		}
		
		if($this->useCaptcha($manager, 'comment')) {
			if($_SESSION['jmp_captcha_'] != $values['captcha']) {
				$v->setError('captcha_text_msg', 'captcha', 'captcha');
			}
		}
				
		return $v->getErrors();
	}
}
?>