<?php
//**********************************************************************************
//** JumperView_login.php - Client View Login
//** This file contains the client view login written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperView_login extends JumperView_common
{
	
	var $login_msg = array('comment' => 'need_to_login_comment',
	                       'contact' => 'need_to_login_contact',
					       'enter' => 'need_to_login_enter',
					       'entry' => 'need_to_login_entry',
					       'category' => 'need_to_login_category',
						   'getfile' => 'need_to_login_file',
						   'authtime' => 'need_to_login_authtime');
	
	
	function &execute(&$manager) {
		
		$file = $this->getMsgFile('user_msg.ini', false);
		$this->msg = array_merge($this->msg, AppMsg::parseMsgs($file));
		
		$this->home_link = true;
		$this->meta_title = $this->msg['login_msg'];
		$this->category_nav_generate = false; // not to generate categories in navigation line
		
		$data = $this->getTop($manager, $this->msg['login_msg'], false);
		$data .= $this->getForm($manager);
		
		return $data;
	}
	

	function getForm($manager) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'login_form.html');
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('forgot_password_link', $this->_getLink('password'));
		$tpl->tplAssign('register_link', $this->_getLink('register'));
		
		
/*
		$view = array_search($this->msg_id, $this->login_msg);		
		if($view == 'getfile') {
			$cancel_link = $this->_getLink('files');
		} elseif($view == 'entry'){
			$cancel_link = $this->_getLink($view);	
		} else {
			$cancel_link = $this->_getLink($view, $this->category_id, $this->entry_id);
		}
		
		$tpl->tplAssign('cancel_link', $cancel_link);
*/
		
		
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		if($manager->getSetting('register_policy')) {
			$tpl->tplSetNeeded('/register_link');
		}
		
		if(!$manager->getSetting('jmp_register_access')) {
			$tpl->tplSetNeeded('/cancel_button');
		}		
		
		
		$tpl->tplParse(array_merge($this->msg, $this->getFormData()));
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values, $manager) {
		
		require_once 'jumper_lib/Validator.php';
		
		$v =& new Validator($values, false);
		$v->requiredArray('required_msg', array('username', 'password'));
		if($v->getErrors()) {
			return $v->getErrors();
		}
		
		
		$auth = &new AuthMember();
		$auth->tbl->table = $manager->tbl->user;
		
		$remember = (isset($values['remember']));
		$ret = $auth->doAuth($values['username'], $values['password'], $remember);
		
		if($ret == false) {
			$v->setError('wrong_login_info_msg', 1);			
		}
		
		return $v->getErrors();
	}
}
?>