<?php
//**********************************************************************************
//** JumperView_password.php - Client View Password
//** This file contains the client view password written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

require_once 'jumper_lib/Validator.php';
require_once 'jumper_lib/Util/PasswordUtil.php';
	

class JumperView_password extends JumperView_common
{
	

	function &execute(&$manager) {
		
		$file = AppMsg::getCommonMsgFile('user_msg.ini');
		$this->msg = array_merge($this->msg, AppMsg::parseMsgs($file));
		
		$this->home_link = true;
		$this->meta_title = $this->msg['forgot_password_msg'];
		
		$data = $this->getTop($manager, $this->msg['forgot_password_msg'], false);
		$data .= $this->getForm();
		
		return $data;
	}
	

	function getForm() {
		
		$tpl = &new tplTemplatez($this->template_dir . 'password_form.html');
		
		if($this->getErrors()) { $tpl->tplAssign('user_msg', $this->getErrors()); }
		
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink());															  
		
		$tpl->tplParse(array_merge($this->msg, $this->getFormData()));
		return $tpl->tplPrint(1);
	}
}
?>