<?php
//**********************************************************************************
//** JumperView_print.php - Client View Print
//** This file contains the client view print written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperView_print extends JumperView_common
{

	function execute(&$manager) {
		
		if($this->msg_id == 'glossary') {
			return $this->getGloassary($manager);
		} else {
			return $this->getProfile($manager);
		}
	}
	
	
	function getProfile(&$manager) {
		
		$row = &$manager->getEntryById($this->entry_id, $this->category_id);
		$row = &$this->stripVars($row);
		if(empty($row)) { return; }
		
		$tpl = &new tplTemplatez($this->template_dir . 'profile_print.html');
	
		$tpl->tplAssign('formated_date', $this->getFormatedDate($row['ts_updated']));	
		$tpl->tplAssign('meta_charset', $this->conf['lang']['meta_charset']);
		$tpl->tplAssign($this->css);
		
		$tpl->tplParse(array_merge($row, $this->msg));
		return $tpl->tplPrint(1);	
	}
	
	
	function getGloassary(&$manager) {
				
		$tpl = &new tplTemplatez($this->template_dir . 'glossary_print.html');
		
		foreach($manager->getGlossaryDefinitions() as $k => $v) {
			$v['phrase'] = $k;
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign('title',  $this->msg['glossary_msg']);
		$tpl->tplAssign('meta_charset', $this->conf['lang']['meta_charset']);	
		$tpl->tplAssign($this->css);
		
		$tpl->tplParse($this->msg);
		return $tpl->tplPrint(1);
	}
}
?>