<?php
//**********************************************************************************
//** JumperView_register.php - Client View Register
//** This file contains the client view register written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

require_once 'core/base/BaseObj.php';
require_once 'core/app/AppObj.php';

require_once APP_MODULE_DIR . 'member/inc/Member.php';
require_once APP_MODULE_DIR . 'member/inc/MemberModel.php';


class JumperView_register extends JumperView_common
{
	
	var $update = false;
	
	
	function JumperView_register() {
		
		parent::JumperView();
		$this->obj = new Member;
		
		$file = $this->getMsgFile('user_msg.ini', false);
		$this->msg = array_merge($this->msg, AppMsg::parseMsgs($file));
	}
	

	function &execute(&$manager) {
		
		if($this->update) { $title = $this->msg['update_member_msg']; } 
		else              { $title = $this->msg['register_msg']; }
		
		$this->home_link = true;
		$this->meta_title = '';
		
		$data = $this->getTop($manager, $title, false);
		$data .= $this->getForm($manager, $title);
		
		return $data;		
	}
	

	function getForm($manager, $title) {
		
		$tpl = &new tplTemplatez($this->template_dir . 'register_form.html');
		
		if($this->update) {
			$tpl->tplSetNeededGlobal('update');
			
			$val = ($_POST) ? $_POST['remember'] : AuthMember::getCookie();
			$val = ($val) ? 'checked' : '';
			$tpl->tplAssign('remember_option', $val);
		}
		
		$tpl->tplAssign('id', $manager->user_id);
		$tpl->tplAssign('title_msg', $title);
		$tpl->tplAssign('action_link', $this->_getLink('all'));
		$tpl->tplAssign('cancel_link', $this->_getLink());															  
		$tpl->tplAssign('user_msg', $this->getErrors());
		
		if($this->useCaptcha($manager, 'register')) {
			$tpl->tplSetNeeded('/captcha');
			$tpl->tplAssign('captcha_src', $this->getCaptchaSrc());
		}		
		
		// not change checkbox
		@$val = ($_POST) ? $_POST['not_change_pass'] : 1;
		$val = ($val) ? 'checked' : '';
		$tpl->tplAssign('pass_change_checked', $val);
		
		
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($this->getFormData());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}	
	
	
	
	function validate($values, $manager, $manager_1) {
		
		$this->obj->validate($values, $manager_1);
		if($this->obj->errors) {
			return $this->obj->errors;
		}
		
		
		$v =& new Validator($values, false);
		
		if($this->useCaptcha($manager, 'register')) {
			if($_SESSION['jmp_captcha_'] != $values['captcha']) {
				$v->setError('captcha_text_msg', 'captcha', 'captcha');
			}
		}		
		
		return $v->getErrors();		
	}
}
?>