<?php
//**********************************************************************************
//** JumperView_rssfeed.php - Client View RSS Feed
//** This file contains the client view RSS feed written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperView_rssfeed extends JumperView_common
{

	function &execute(&$manager) {
		
		$this->home_link = true;
		$this->meta_title = &$this->msg['rss_title_msg'];
		//$this->meta_keywords = &$row['meta_keywords'];
		//$this->meta_location = &$row['meta_location'];

		$data = $this->getTop($manager, $this->meta_title);
		$data .= $this->getList($manager);
		
		return $data;		
	}
	
	
	function getList(&$manager)  {
		
		$tpl = &new tplTemplatez($this->template_dir . 'rss_list.html');
		
		$rss_title = $manager->getSetting('rss_title');
		$rss_description = $manager->getSetting('rss_description');
		$rss_file = $this->controller->jmp_path . 'rss.php';

		$rows = array();
		$rows[0]['title'] = $rss_title;
		$rows[0]['description'] = $rss_description;
		$rows[0]['rss_link'] = $rss_file;
		
		// top
		if($manager->getSetting('rss_generate') == 'top') {
			
			$categories = $manager->getCategoryRssData();
			
			foreach($categories as $category_id => $v) {
				$rows[$category_id]['title'] = sprintf('%s', $v['title']);
				$rows[$category_id]['description'] = sprintf('%s', $v['description']);
				$rows[$category_id]['rss_link'] = $rss_file . '?c=' . $category_id;
				
				unset($categories[$category_id]);
			}
		}
		
		$rows = &$this->stripVars($rows);
		
		foreach($rows as $k => $v) {
			$v['jmp_path'] = $this->controller->client_path;
			//$v['row_class'] = $this->getRowClass();
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign('title_msg', $this->msg['rss_title_msg']);
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
}
?>