<?php
//**********************************************************************************
//** JumperView_send.php - Client View Send
//** This file contains the client view send written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperView_send extends JumperView_common
{

	function &execute(&$manager) {
		
		$row = &$manager->getEntryById($this->entry_id, $this->category_id);
		$row = &$this->stripVars($row);
		if(!$row) { return; }
		
		$this->meta_title = $this->msg['send_link_msg'];
		$title = ''; //($this->controller->getSetting('show_title_nav')) ? $row['title'] : '';
		
		$data = $this->getTop($manager, $title, false);
		$data .= $this->getForm($manager, $title);
		$data .= $this->getEntry($manager, $row);
		
		return $data;		
	}
	
	
	function getEntry(&$manager, &$row)  {
		$tpl = &new tplTemplatez($this->template_dir . 'profile.html');
		$tpl->tplParse(array_merge($row, $this->msg));
		return $tpl->tplPrint(1);
	}
	

	function getForm($manager, $entry_title) {
		$tpl = &new tplTemplatez($this->template_dir . 'send_form.html');
		
		$tpl->tplAssign('user_msg', $this->getErrors());
		$tpl->tplAssign('action_link', $this->_getLink('all'));
															  
		
		if($manager->is_registered && !$_POST) {
			$data = $this->stripVars($manager->getUserInfo($manager->user_id));
			$tpl->tplAssign('your_email', $data['email']);
			$tpl->tplAssign('name', $data['first_name'] . ' ' . $data['last_name']);
		}
		
		
		$link = $this->_getLink('entry', $this->category_id, $this->entry_id);
		
		// hidden	
		$tpl->tplAssign('entry_link', $link);
		$tpl->tplAssign('entry_title', $entry_title);
		
		$tpl->tplAssign('cancel_link', $link);
		$tpl->tplAssign($this->msg);
		$tpl->tplAssign($this->getFormData());
		
		$tpl->tplParse();
		return $tpl->tplPrint(1);
	}
	
	
	function validate($values) {
		
		require_once 'jumper_lib/Validator.php';
		
		$v =& new Validator($values, false);
		$v->required('required_msg', 'name');
		$v->regex('email_msg', 'email', 'your_email');
		$v->regex('email_msg', 'email', 'friend_email');
		
		return $v->getErrors();
	}
}
?>