<?php
//**********************************************************************************
//** JumperModel_common.php - Common Client Model
//** This file contains the common client model written by Evgen Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************


class JumperModel_common extends JumperModel
{
	
	function _getCategoryListSql($parent_id) {
	
		$sort = $this->getSetting('category_sort_order');
		
		$sql = "
		SELECT 
			c.*,
			COUNT(DISTINCT ec.category_id) AS num_entries
		FROM 
			{$this->tbl->category} c
		LEFT JOIN {$this->tbl->entry_to_category} ec ON c.id = ec.category_id 
		
		WHERE 1
			AND c.active = 1
		GROUP BY c.id
		ORDER BY {$sort}";
		
		echo "<pre>"; print_r($sql); echo "</pre>";
		return $sql;
	}


	function &getCategoryList($parent_id) {
		
		$needed_keys = array('id', 'name');
		$data = array();
		
		$sql = $this->_getCategoryListSql($parent_id);
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		while($row = $result->FetchRow()) {
		
			//if($row['num_entries'] == 0) { continue; }
			$data[$row['id']] = array_diff_key($row, $needed_keys);
		}

		//echo "<pre>"; print_r($data); echo "</pre>";
		return $data;
	}
	
	
	function &getEntryList($body_words = 'all') {
		
		$needed_keys = array('id', 'title', 'body');
		$data = array();
		
		$sort = $this->getSetting('category_sort_order');
		$this->setSqlParamsOrder('ORDER BY cat.' . $sort);
		
		$sql = $this->getEntriesSql($body_words);
		$result =& $this->db->Execute($sql) or die(db_error($sql));
		while($row = $result->FetchRow()) {
		
			$data[$row['category_id']][] = array_diff_key($row, $needed_keys);
		}

		//echo "<pre>"; print_r($data); echo "</pre>";
		return $data;
	}
}
?>