<?php
//**********************************************************************************
//** JumperView_default.php - Default Client View
//** This file contains the common client view written by Evgen Leontevm (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008-2009 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

class JumperView_default extends JumperView_common
{	
	

	function &execute(&$manager) {
		
		$categories = &$this->stripVars($manager->getCategoryList(0));
		$entries = &$this->stripVars($manager->getEntryList());

		$data = array();
		$data[] = &$this->getCategoryList($categories, $entries, $manager);
		$data[] = &$this->getEntryList($categories, $entries, $manager);		
		$data = implode('', $data);
		
		return $data;
	}
	 
	
	function &getCategoryList($rows, $entries, $manager) {
		
		if(!$rows)             { return; }
		//$one_category = (count($rows) == 1);
		
		$tpl = &new tplTemplatez($this->template_dir . 'category_list.html');
	
		foreach($rows as $cat_id => $v) {
			
			$v['category_link'] = $this->_getLink('category_', false, $v['id'], true);
			$v['item_img'] = $this->_getItemImg($manager->is_registered, false, true);
			
			//if($one_category) { $v = array(); }
			
			foreach($entries[$cat_id] as $k => $entry) {
				
				$e = array();
				$e['title'] = $entry['title'];
				$e['entry_link'] = $this->_getLink('entry_', false, $entry['id'], true);
				
				$tpl->tplParse($e, 'row/row_entry');
			}

			$tpl->tplSetNested('row/row_entry');
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		
		return $tpl->tplPrint(1);
	}
	
	
	function &getEntryList($rows, $entries, $manager) {
		
		if(!$entries) { return; }
		
		$tpl = &new tplTemplatez($this->template_dir . 'profile_list.html');
	
		foreach($rows as $cat_id => $v) {
				
			$v['category_link'] = $this->_getLink('category_', false, $v['id'], true);
			$v['item_img'] = $this->_getItemImg($manager->is_registered, false, true);
			
			foreach($entries[$cat_id] as $k => $entry) {
				
				$e = array();
				$e['id'] = $entry['id'];
				$e['item_img'] = $this->_getItemImg($manager->is_registered, false, false);
				$e['title'] = $entry['title'];
				//$e['body'] = $this->_parseGlossaryItems($entry['body'], $manager);
				
				$e['body'] = DocumentParser::parseGlossaryItems($entry['body'], $manager);		
				//$e['body'] = DocumentParser::parseLink($row['body'], array($this, '_getLink'));
				
				$e['entry_link'] = $this->_getLink('entry_', false, $entry['id'], true);
				
				$tpl->tplParse($e, 'row/row_entry');
			}

			$tpl->tplSetNested('row/row_entry');
			$tpl->tplParse($v, 'row');
		}
		
		$tpl->tplAssign('base_href', $this->conf['client_home_path']);
		$tpl->tplAssign($this->msg);
		$tpl->tplParse();
		
		return $tpl->tplPrint(1);
	}
}
?>