//************************************************************************************
//** OnkeyRequestBuffer.js - Buffer class
//** This file contains the buffer class written by Evgeny Leontev (c) 2005
//** modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Patents Pending
//**Copyright: Permission is granted for redistribution of this file
//**Copyright: provided this copyright notice is maintained intact. If you 
//**Copyright: alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//************************************************************************************

var OnKeyRequestBuffer =
    {
        bufferText: false,
        bufferTime: 700,

		
		getStr : function(str) 
		{
			str = str.replace(/\n/g, " ");
			str = str.replace(/"/g, "");

			return str;
		},

        modified : function(strId)
        {
			var strText = OnKeyRequestBuffer.getStr(xajax.$(strId).value);
            setTimeout('OnKeyRequestBuffer.compareBuffer("'+strId+'", "'+strText+'");', this.bufferTime);
        },

        compareBuffer : function(strId, strText)
        {
		   var strText1 = OnKeyRequestBuffer.getStr(xajax.$(strId).value);
		   if (strText == strText1 && strText != this.bufferText)                     
            {
                this.bufferText = strText;
                OnKeyRequestBuffer.makeRequest(strId);
            }
        },

        makeRequest : function(strId)
        {
            xajax_requestBuffer(xajax.$(strId).value);
        }
    }

/*
This class will only execute the code in the OnKeyRequestBuffer.makeRequest function
if the text in the input with the given id has not changed in a half of a second (500 ms).
So now, instead of calling the xajax function directly in the onkeyup event, we call our buffer class:

<input id="myText" type="text" onkeyup="OnKeyRequestBuffer.modified('myText');" />
*/
