-- upgrade from version 1.5... to 2.0
-- You can(should) safely run it.

-- if you upgrading from earlier version then you shold run those upgrades first
 

-- add one more fields, index to member
ALTER TABLE `s_member` ADD `member_comment` TEXT NOT NULL AFTER `phone`;
ALTER TABLE `s_member` ADD `admin_comment` TEXT NOT NULL AFTER `member_comment`;
ALTER TABLE `s_member` ADD `role_id` TINYINT NOT NULL AFTER `id`;
ALTER TABLE `s_member` ADD INDEX role_id (role_id);

-- add private to entry
ALTER TABLE `s_jmp_entry` ADD `private` TINYINT(1) DEFAULT "0" NOT NULL AFTER `sort_order`;

-- add meta to entry
ALTER TABLE `s_jmp_entry` ADD `meta_keywords` TEXT NOT NULL AFTER `body`;
ALTER TABLE `s_jmp_entry` ADD `meta_location` TEXT NOT NULL AFTER `meta_keywords`;
ALTER TABLE `s_jmp_entry` ADD `meta_link` TEXT NOT NULL AFTER `meta_location`;
ALTER TABLE `s_jmp_entry` ADD `meta_datatype` TEXT NOT NULL AFTER `meta_link`;
ALTER TABLE `s_jmp_entry` DROP INDEX `title` , ADD FULLTEXT `title` (`title` ,`body` ,`meta_keywords` ,`meta_location` ,`meta_link`,`meta_datatype`);
ALTER TABLE `s_jmp_entry` ADD INDEX ( `meta_keywords` ( 10 ) );
ALTER TABLE `s_jmp_entry` ADD INDEX ( `meta_datatype` ( 3 ) );

-- add url_title to entry
ALTER TABLE `s_jmp_entry` ADD `url_title` VARCHAR(255)  NOT NULL AFTER `body`;
ALTER TABLE `s_jmp_entry` ADD INDEX ( `url_title` ( 10 ) );

-- change settings
ALTER TABLE `s_setting` CHANGE `input_id` `input_id` TINYINT UNSIGNED DEFAULT "0" NOT NULL;
ALTER TABLE `s_setting_input` CHANGE `id` `id` TINYINT UNSIGNED NOT NULL AUTO_INCREMENT;

-- add is main to entry_to_category
ALTER TABLE `s_jmp_entry_to_category` ADD `is_main` TINYINT(1) DEFAULT "1" NOT NULL;
ALTER TABLE `s_jmp_entry_to_category` ADD INDEX ( `entry_id` );

-- add num_entry to entry_to_category
ALTER TABLE `s_jmp_category` ADD `num_entry` SMALLINT UNSIGNED NOT NULL AFTER `sort_order`;


-- tables

-- --------------------------------------------------------

-- 
-- Table structure for table `s_data_to_user_rule`
-- 

DROP TABLE IF EXISTS `s_data_to_user_rule`;
CREATE TABLE `s_data_to_user_rule` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_data_to_user_rule`
-- 

INSERT INTO `s_data_to_user_rule` (`id`, `title`) VALUES (1, 'jmp_category_to_admin'),
(2, 'jmp_category_to_admin_role'),
(3, 'jmp_category_to_member'),
(4, 'jmp_category_to_member_role'),
(5, 'file_category_to_admin'),
(6, 'file_category_to_admin_role'),
(7, 'file_category_to_member'),
(8, 'file_category_to_member_role'),
(9, 'jmp_entry_to_admin'),
(10, 'jmp_entry_to_admin_role'),
(11, 'jmp_entry_to_member'),
(12, 'jmp_entry_to_member_role'),
(13, 'file_entry_to_admin'),
(14, 'file_entry_to_admin_role'),
(15, 'file_entry_to_member'),
(16, 'file_entry_to_member_role');

-- --------------------------------------------------------

-- 
-- Table structure for table `s_data_to_user_value`
-- 

DROP TABLE IF EXISTS `s_data_to_user_value`;
CREATE TABLE `s_data_to_user_value` (
  `rule_id` int(11) NOT NULL default '0',
  `data_value` int(11) NOT NULL default '0',
  `user_value` int(11) NOT NULL default '0',
  KEY `rule_id` (`rule_id`),
  KEY `data_value` (`data_value`)
) ENGINE=MyISAM;


-- --------------------------------------------------------

-- 
-- Table structure for table `s_feedback`
-- 

DROP TABLE IF EXISTS `s_feedback`;
CREATE TABLE `s_feedback` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned default NULL,
  `admin_id` int(10) unsigned NOT NULL default '0',
  `category_id` int(10) unsigned NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `question` text NOT NULL,
  `attachment` text NOT NULL,
  `answer` text NOT NULL,
  `date_posted` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_answered` datetime NOT NULL default '0000-00-00 00:00:00',
  `answered` tinyint(1) NOT NULL default '0',
  `placed` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `NewIndex` (`user_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `s_file_category`
-- 

DROP TABLE IF EXISTS `s_file_category`;
CREATE TABLE `s_file_category` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `parent_id` int(10) unsigned NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `sort_order` tinyint(3) unsigned NOT NULL default '0',
  `num_entry` smallint(5) unsigned NOT NULL default '0',
  `private` tinyint(1) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_file_category`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `s_file_entry`
-- 

DROP TABLE IF EXISTS `s_file_entry`;
CREATE TABLE `s_file_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `creator_id` int(10) unsigned NOT NULL default '0',
  `updater_id` int(10) unsigned NOT NULL default '0',
  `directory` varchar(255) NOT NULL default '',
  `sub_directory` varchar(255) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `filesize` int(10) unsigned NOT NULL default '0',
  `filetype` varchar(50) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `description_full` text NOT NULL,
  `comment` text NOT NULL,
  `date_updated` timestamp NOT NULL,
  `date_posted` datetime NOT NULL default '0000-00-00 00:00:00',
  `downloads` int(10) unsigned NOT NULL default '0',
  `filetext` text NOT NULL,
  `sort_order` smallint(5) unsigned NOT NULL default '1',
  `private` tinyint(1) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `creator_id` (`creator_id`),
  KEY `filename` (`filename`(4)),
  KEY `updater_id` (`updater_id`),
  FULLTEXT KEY `title` (`title`,`description`,`filetext`)
) ENGINE=MyISAM COMMENT='images per item';

-- 
-- Dumping data for table `s_file_entry`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `s_file_entry_to_category`
-- 

DROP TABLE IF EXISTS `s_file_entry_to_category`;
CREATE TABLE `s_file_entry_to_category` (
  `entry_id` int(10) unsigned NOT NULL default '0',
  `category_id` int(10) unsigned NOT NULL default '0',
  `is_main` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`entry_id`,`category_id`)
) ENGINE=MyISAM;


-- --------------------------------------------------------

-- 
-- Table structure for table `s_jmp_attachment_to_entry`
-- 

DROP TABLE IF EXISTS `s_jmp_attachment_to_entry`;
CREATE TABLE `s_jmp_attachment_to_entry` (
  `entry_id` int(10) unsigned NOT NULL default '0',
  `attachment_id` int(10) unsigned NOT NULL default '0',
  `attachment_type` tinyint(1) NOT NULL default '0',
  KEY `entry_id` (`entry_id`),
  KEY `attachment_id` (`attachment_id`)
) ENGINE=MyISAM;


-- --------------------------------------------------------

-- 
-- Table structure for table `s_jmp_related_to_entry`
-- 

DROP TABLE IF EXISTS `s_jmp_related_to_entry`;
CREATE TABLE `s_jmp_related_to_entry` (
  `entry_id` int(10) unsigned NOT NULL default '0',
  `related_entry_id` int(10) unsigned NOT NULL default '0',
  `related_type` tinyint(1) NOT NULL default '0',
  KEY `entry_id` (`entry_id`),
  KEY `attachment_id` (`related_entry_id`)
) ENGINE=MyISAM;


-- --------------------------------------------------------

-- 
-- Table structure for table `s_letter_template`
-- 

DROP TABLE IF EXISTS `s_letter_template`;
CREATE TABLE `s_letter_template` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `letter_key` varchar(20) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `from_email` varchar(255) NOT NULL default '',
  `from_name` varchar(255) NOT NULL default '',
  `to_email` varchar(255) NOT NULL default '',
  `to_name` varchar(255) NOT NULL default '',
  `to_cc_email` varchar(255) NOT NULL default '',
  `to_cc_name` varchar(255) NOT NULL default '',
  `to_bcc_email` varchar(255) NOT NULL default '',
  `to_bcc_name` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `body` text,
  `skip_field` varchar(255) NOT NULL default '',
  `is_html` tinyint(1) NOT NULL default '0',
  `in_out` tinyint(4) NOT NULL default '1',
  `predifined` tinyint(1) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_letter_template`
-- 

INSERT INTO `s_letter_template` (`id`, `letter_key`, `title`, `description`, `from_email`, `from_name`, `to_email`, `to_name`, `to_cc_email`, `to_cc_name`, `to_bcc_email`, `to_bcc_name`, `subject`, `body`, `skip_field`, `is_html`, `in_out`, `predifined`, `active`) VALUES (1, 'send_to_friend', '', '', '', '', '', '', '', '', '', '', '', NULL, 'to,from', 0, 2, 1, 1),
(2, 'answer_to_user', '', '', '[support_email]', '[support_name]', '[email]', '[first_name] [last_name]', '', '', '', '', '', NULL, '', 0, 1, 1, 1),
(3, 'contact', '', '', '', '', '[support_email]', '[support_name]', '', '', '', '', '', NULL, 'from', 0, 1, 1, 1),
(4, 'confirm_registration', '', '', '', '', '', '', '', '', '', '', '', NULL, 'to,from', 0, 2, 1, 1),
(5, 'generated_password', '', '', '', '', '', '', '', '', '', '', '', NULL, 'to,from', 0, 2, 1, 1);


-- --------------------------------------------------------

-- 
-- Table structure for table `s_priv_module`
-- 

DROP TABLE IF EXISTS `s_priv_module`;
CREATE TABLE `s_priv_module` (
  `id` smallint(6) NOT NULL default '0',
  `parent_id` smallint(6) NOT NULL default '0',
  `parent_setting_id` tinyint(1) NOT NULL default '0',
  `module_name` varchar(30) NOT NULL default '0',
  `menu_name` varchar(50) NOT NULL default '',
  `use_in_sub_menu` enum('NO','YES_DEFAULT','YES_NOT_DEFAULT') default NULL,
  `as_sub_menu` tinyint(1) NOT NULL default '0',
  `by_default` varchar(30) NOT NULL default '',
  `own_priv` tinyint(1) NOT NULL default '0',
  `check_priv` tinyint(1) NOT NULL default '1',
  `active` tinyint(1) NOT NULL default '1',
  `sort_order` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_priv_module`
-- 

INSERT INTO `s_priv_module` (`id`, `parent_id`, `parent_setting_id`, `module_name`, `menu_name`, `use_in_sub_menu`, `as_sub_menu`, `by_default`, `own_priv`, `check_priv`, `active`, `sort_order`) VALUES (0, 0, 0, 'all', '', 'NO', 0, '', 0, 1, 1, 0),
(1, 0, 0, 'user', 'Administrators', 'NO', 0, 'user', 0, 1, 1, 20),
(3, 0, 0, 'setting', 'Settings', 'NO', 0, 'jmp_setting', 0, 1, 1, 21),
(5, 0, 0, 'member', 'Members', 'NO', 0, 'member', 0, 1, 1, 3),
(100, 0, 3, 'knowledgebase', 'KnowledgeBase', 'YES_DEFAULT', 0, 'jmp_entry', 1, 1, 1, 1),
(2, 1, 0, 'privilege', 'Pivilege', 'NO', 1, '', 0, 1, 0, 1),
(101, 100, 0, 'jmp_entry', 'Questions', 'NO', 0, '', 0, 1, 1, 1),
(102, 100, 0, 'jmp_category', 'Categories', 'NO', 0, '', 0, 1, 1, 15),
(104, 100, 0, 'jmp_comment', 'Comments', 'NO', 0, '', 0, 1, 1, 3),
(105, 100, 0, 'jmp_glossary', 'Glossary', 'NO', 0, '', 0, 1, 1, 4),
(131, 3, 3, 'sys_setting', 'System', 'NO', 0, '', 0, 1, 0, 0),
(10, 1, 0, 'user', 'Administrators', 'NO', 0, '', 0, 1, 1, 0),
(8, 0, 0, 'feedback', 'Feedback', 'NO', 0, 'feedback', 0, 1, 1, 2),
(130, 3, 0, 'jmp_setting', 'KnowledgeBase', 'NO', 0, '', 0, 1, 1, 1),
(108, 100, 0, 'jmp_attachment', 'Attachments', 'NO', 0, '', 0, 1, 0, 20),
(200, 0, 3, 'file', 'Files', 'NO', 0, 'file_entry', 0, 1, 1, 2),
(202, 200, 0, 'file_category', 'Categories', 'NO', 0, '', 0, 1, 1, 2),
(109, 100, 0, 'jmp_client', 'Client View', 'NO', 0, '', 0, 0, 1, 23),
(132, 3, 0, 'letter_template', 'Letter Template', 'NO', 0, '', 0, 1, 1, 12),
(133, 3, 0, 'file_setting', 'Files', 'NO', 0, '', 0, 1, 1, 5),
(50, 5, 0, 'member', 'Members', 'NO', 0, '', 0, 1, 1, 0),
(51, 5, 0, 'member_role', 'Roles', 'NO', 0, '', 0, 1, 1, 2),
(11, 1, 0, 'user_role', 'Roles', 'NO', 0, '', 0, 1, 0, 2),
(300, 0, 0, 'ticket', 'Tickets', 'NO', 0, '', 0, 1, 0, 0),
(201, 200, 0, 'file_entry', 'Files', 'NO', 0, '', 0, 1, 1, 1),
(134, 3, 0, 'email_setting', 'Email', 'NO', 0, '', 0, 1, 1, 11),
(6, 0, 0, 'sys', 'Sys', 'NO', 0, 'php_info', 0, 1, 0, 30),
(61, 6, 0, 'php_info', 'PHP info', 'NO', 0, 'php_info', 0, 1, 1, 1),
(62, 6, 0, 'db_info', 'DB info', 'NO', 0, 'db_info', 0, 1, 1, 2),
(9, 0, 0, 'account', 'My Account', 'NO', 0, 'account', 0, 0, 1, 100),
(135, 3, 0, 'cron', 'Sheduled Tasks', 'NO', 0, '', 0, 1, 0, 15),
(91, 9, 0, 'account', 'My Account', 'NO', 0, '', 0, 0, 1, 1),
(80, 8, 0, 'feedback', 'Feedback', 'NO', 0, '', 0, 1, 1, 0),
(203, 200, 0, 'file_bulk', 'Bulk', 'NO', 0, '', 0, 1, 1, 3);


-- --------------------------------------------------------

-- 
-- Table structure for table `s_priv_name`
-- 

DROP TABLE IF EXISTS `s_priv_name`;
CREATE TABLE `s_priv_name` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  `statusable` enum('yes','no') NOT NULL default 'yes',
  `info_editable` enum('yes','no') NOT NULL default 'yes',
  `priv_editable` enum('yes','no') NOT NULL default 'yes',
  `deleteable` enum('yes','no') NOT NULL default 'yes',
  `sort_order` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_priv_name`
-- 

INSERT INTO `s_priv_name` (`id`, `name`, `description`, `active`, `statusable`, `info_editable`, `priv_editable`, `deleteable`, `sort_order`) VALUES (1, 'Admin', 'User has all privileges.', 1, 'no', 'yes', 'yes', 'no', 1),
(2, 'KnowledgeBase Moderator', 'User has all privileges for knowledgebase.', 1, 'yes', 'yes', 'yes', 'yes', 2),
(3, 'KnowledgeBase Editor', 'User has privileges for Knowledgebase\r\n(Edit, Delete - Questions, Comments, Site Visitors questions)', 1, 'yes', 'yes', 'yes', 'yes', 3),
(4, 'Knowledgebase creator', '', 1, 'yes', 'yes', 'yes', 'yes', 4),
(5, 'Knowledgebase creator (not trusted)', '', 1, 'yes', 'yes', 'yes', 'yes', 5);


-- --------------------------------------------------------

-- 
-- Table structure for table `s_priv_rule`
-- 

DROP TABLE IF EXISTS `s_priv_rule`;
CREATE TABLE `s_priv_rule` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `priv_name_id` smallint(6) NOT NULL default '0',
  `priv_module_id` smallint(6) NOT NULL default '0',
  `what_priv` set('select','self_select','insert','update','self_update','status','self_status','delete','self_delete') NOT NULL default '',
  `apply_to_child` tinyint(1) unsigned NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `Table_priv` (`priv_module_id`),
  KEY `name_priv_id` (`priv_name_id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_priv_rule`
-- 

INSERT INTO `s_priv_rule` (`id`, `priv_name_id`, `priv_module_id`, `what_priv`, `apply_to_child`, `active`) VALUES (1, 1, 0, 'select,insert,update,status,delete', 0, 1),
(2, 2, 100, 'select,insert,update,status,delete', 1, 1),
(3, 2, 1, 'select', 0, 1),
(4, 3, 1, 'select', 0, 1),
(5, 3, 101, 'select,insert,update,status,delete', 0, 1),
(6, 3, 104, 'select,insert,update,status,delete', 0, 1),
(7, 3, 107, 'select,insert,update,status,delete', 0, 1),
(11, 2, 200, 'select,insert,update,status,delete', 1, 1),
(9, 3, 108, 'select,insert,update,status,delete', 0, 1),
(10, 2, 5, 'select,insert,update,status,delete', 0, 1),
(12, 3, 5, 'select', 0, 1),
(13, 3, 201, 'select,insert,update,status,delete', 0, 1),
(14, 4, 1, 'select,self_update', 0, 0),
(15, 4, 101, 'self_select,insert,self_update,self_status,self_delete', 0, 1),
(16, 4, 201, 'self_select,insert,self_update,self_status,self_delete', 0, 1),
(17, 5, 1, 'self_select,self_update', 0, 0),
(18, 5, 101, 'self_select,insert,self_update,self_delete', 0, 1),
(19, 5, 201, 'self_select,insert,self_update,self_delete', 0, 1),
(20, 2, 8, 'select,insert,update,status,delete', 1, 1),
(21, 3, 8, 'select,insert,update,status,delete', 1, 1);


-- --------------------------------------------------------

-- 
-- Table structure for table `s_role`
-- 

DROP TABLE IF EXISTS `s_role`;
CREATE TABLE `s_role` (
  `id` tinyint(4) NOT NULL auto_increment,
  `role_key` varchar(10) NOT NULL default '',
  `title` varchar(50) NOT NULL default '',
  `description` text NOT NULL,
  `active` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;


-- --------------------------------------------------------

-- 
-- Table structure for table `s_setting`
-- 

DROP TABLE IF EXISTS `s_setting`;
CREATE TABLE `s_setting` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `module_id` int(10) unsigned NOT NULL default '0',
  `group_id` tinyint(3) unsigned NOT NULL default '0',
  `input_id` tinyint(3) unsigned NOT NULL default '0',
  `options` varchar(100) NOT NULL default '',
  `setting_key` varchar(255) NOT NULL default '',
  `messure` varchar(10) NOT NULL default '',
  `range` varchar(255) NOT NULL default '',
  `default_value` varchar(255) NOT NULL default '',
  `sort_order` float NOT NULL default '0',
  `required` tinyint(1) NOT NULL default '0',
  `skip_default` tinyint(1) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `s_setting`
-- 

INSERT INTO `s_setting` VALUES (1, 100, 4, 1, '', 'allow_comments', '', '0,1,2', '1', '12', 0, 0, 1),
(2, 100, 4, 4, '', 'allow_rating', '', '', '1', '14', 0, 0, 1),
(3, 100, 4, 1, '', 'allow_post_entry', '', '0,1,2', '1', '11', 0, 0, 0),
(4, 100, 3, 1, '', 'num_most_viewed_entries', '', '0,3,5,10,15', '5', '8', 0, 0, 1),
(5, 100, 3, 1, '', 'num_recently_posted_entries', '', '0,3,5,10,15', '5', '7', 0, 0, 1),
(6, 100, 3, 1, '', 'num_entries_per_page', '', '10,15,20', '10', '6', 0, 0, 1),
(7, 100, 8, 1, 'onchange="populateSelect(myOptions[this.value]);"', 'view_format', '', 'default', 'default', '2', 0, 0, 1),
(8, 100, 6, 4, '', 'show_hits', '', '', '1', '2', 0, 0, 1),
(9, 100, 4, 1, '', 'comment_policy', '', '1,2,3', '1', '13', 0, 0, 1),
(10, 100, 1, 2, 'size="50"', 'site_title', '', '', 'Jumper', '2', 0, 1, 4),
(11, 100, 1, 2, 'size="50"', 'support_email', '', '', 'your@email.com', '10', 0, 1, 0),
(12, 100, 3, 4, '', 'show_glossary_link', '', '', '1', '16', 0, 0, 1),
(13, 100, 8, 2, 'size="50"', 'page_to_load', '', '', 'Default', '1', 0, 0, 1),
(14, 100, 3, 1, '', 'category_sort_order', '', 'name,sort_order', 'sort_order', '10', 0, 0, 1),
(15, 100, 6, 4, '', 'show_send_link', '', '', '1', '1', 0, 0, 1),
(16, 100, 3, 1, '', 'show_num_entries', '', '0,1', '1', '10.1', 0, 0, 1),
(17, 100, 3, 4, '', 'show_title_nav', '', '', '1', '19', 0, 0, 1),
(104, 100, 3, 1, '', 'entry_sort_order', '', 'name,sort_order,added_desc,added_asc,updated_desc,updated_asc,hits_desc,hits_asc', 'sort_order', '1', 0, 0, 1),
(19, 100, 1, 2, 'size="50"', 'nav_title', '', '', 'Knowledgebase', '4', 0, 0, 1),
(20, 200, 1, 2, 'size="50"', 'file_dir', '', '', '[document_root_parent]/jmp_file/', '10', 0, 0, 1),
(21, 200, 1, 4, '', 'file_extract', '', '', '1', '15', 0, 0, 1),
(22, 200, 1, 2, 'size="50"', 'file_denied_extensions', '', '', 'php,php3,php5,phtml,asp,aspx,ascx,jsp,cfm,cfc,pl,bat,exe,dll,reg,cgi', '13', 0, 0, 1),
(106, 100, 2, 1, '', 'register_captcha', '', 'no,yes', 'yes', '3.3', 0, 0, 1),
(23, 200, 1, 2, '', 'file_max_filesize', '', '', '2048', '11', 0, 0, 1),
(24, 200, 1, 1, '', 'file_store', '', 'dir,db', 'dir', '0', 0, 0, 0),
(25, 200, 1, 2, 'size="50"', 'file_allowed_extensions', '', '', '', '12', 0, 0, 1),
(26, 200, 1, 1, '', 'file_rename_policy', '', 'date_Ymd-His,date_Ymd,date_Y,suffics_3', 'date_Ymd-His', '10', 0, 0, 0),
(27, 200, 3, 1, '', 'num_most_viewed_entries', '', '0,3,5,10,15', '5', '3', 0, 0, 1),
(28, 200, 3, 1, '', 'num_recently_posted_entries', '', '0,3,5,10,15', '5', '2', 0, 0, 1),
(29, 200, 3, 1, '', 'num_entries_per_page', '', '10,15,20', '10', '1', 0, 0, 1),
(30, 200, 3, 1, '', 'category_sort_order', '', 'name,sort_order', 'sort_order', '4', 0, 0, 1),
(31, 200, 3, 1, '', 'show_num_entries', '', '0,1', '1', '5', 0, 0, 1),
(34, 100, 3, 4, '', 'show_file_link', '', '', '1', '18', 0, 0, 1),
(33, 100, 2, 4, '', 'jmp_register_access', '', '', '0', '3.1', 0, 0, 1),
(35, 100, 2, 1, '', 'private_policy', '', '1,2', '2', '3.8', 0, 0, 1),
(36, 200, 2, 1, '', 'private_policy', '', '1,2', '2', '0', 0, 0, 1),
(49, 134, 2, 2, 'size="50"', 'smtp_port', '', '', '25', '7', 0, 0, 1),
(38, 100, 2, 4, '', 'register_policy', '', '', '1', '3.2', 0, 0, 1),
(39, 100, 2, 2, 'size="10"', 'auth_expired', '', '', '60', '3.7', 0, 0, 1),
(40, 134, 2, 1, '', 'mailer', '', 'mail,smtp,sendmail', 'mail', '3', 1, 0, 1),
(41, 134, 1, 2, 'size="50"', 'from_email', '', '', '', '2', 1, 1, 1),
(42, 134, 1, 2, 'size="50"', 'from_name', '', '', 'Support Team', '3', 0, 0, 1),
(43, 134, 2, 2, 'size="50"', 'sendmail_path', '', '', '/usr/sbin/sendmail', '4', 0, 0, 1),
(44, 134, 2, 4, '', 'smtp_auth', '', '', '0', '5', 0, 0, 1),
(45, 134, 2, 2, 'size="50"', 'smtp_user', '', '', '', '8', 0, 0, 1),
(46, 134, 2, 2, 'size="50"', 'smtp_pass', '', '', '', '9', 0, 0, 1),
(47, 134, 2, 2, 'size="50"', 'smtp_host', '', '', '', '6', 0, 0, 1),
(50, 100, 5, 2, 'size="10"', 'preview_profile_limit', '', '', '150', '1', 0, 0, 1),
(51, 100, 5, 4, '', 'preview_show_comments', '', '', '1', '4', 0, 0, 1),
(52, 100, 5, 4, '', 'preview_show_rating', '', '', '0', '3', 0, 0, 1),
(53, 100, 5, 4, '', 'preview_show_hits', '', '', '0', '5', 0, 0, 1),
(54, 100, 5, 4, '', 'preview_show_date', '', '', '1', '2', 0, 0, 1),
(55, 100, 6, 4, '', 'show_creator', '', '', '1', '3', 0, 0, 1),
(56, 134, 1, 2, 'size="50"', 'from_mailer', '', '', 'JMP Mailer', '1', 0, 0, 1),
(57, 100, 2, 4, '', 'register_confirmation', '', '', '1', '3.4', 0, 0, 0),
(58, 100, 3, 1, '', 'num_entries_category', '', '0,3,5,10,15,20,all', 'all', '8.1', 0, 0, 1),
(59, 100, 7, 2, 'size="50"', 'rss_title', '', '', 'Knowledgebase RSS', '2', 0, 1, 1),
(60, 100, 7, 3, 'rows="2" style="width: 100%"', 'rss_description', '', '', '', '3', 0, 1, 1),
(61, 100, 7, 1, '', 'rss_generate', '', 'none,one,top', 'one', '1', 0, 0, 1),
(62, 100, 1, 3, 'rows="2" style="width: 100%"', 'site_keywords', '', '', '', '5', 0, 1, 0),
(63, 100, 1, 3, 'rows="2" style="width: 100%"', 'site_description', '', '', '', '6', 0, 1, 0),
(64, 100, 1, 3, 'rows="2" style="width: 100%"', 'site_link', '', '', '', '6', 0, 1, 0),
(65, 100, 3, 1, '', 'num_category_cols', '', '0,1,2,3,4,5', '3', '10.2', 0, 0, 1),
(66, 200, 3, 2, 'size="10"', 'num_category_cols', '', '', '3', '6', 0, 0, 1),
(67, 100, 2, 4, '', 'register_approval', '', '', '0', '3.6', 0, 0, 0),
(105, 100, 4, 1, '', 'comment_captcha', '', 'no,yes,yes_no_reg', 'yes_no_reg', '12.1', 0, 0, 1),
(101, 100, 1, 2, 'size="50"', 'header_title', '', '', 'Knowledgebase', '3', 0, 1, 1),
(102, 100, 4, 1, '', 'allow_contact', '', '0,1,2', '1', '11.2', 0, 0, 1),
(103, 100, 8, 1, '', 'view_template', '', '1', 'default', '3', 0, 0, 1),
(107, 100, 4, 1, '', 'contact_captcha', '', 'no,yes,yes_no_reg', 'no', '11.4', 0, 0, 1),
(108, 100, 4, 1, '', 'entry_captcha', '', 'no,yes,yes_no_reg', 'yes', '11.1', 0, 0, 0),
(109, 100, 4, 4, '', 'contact_attachment', '', '', '1', '11.3', 0, 0, 1);
