<?php
//************************************************************************************
//** rss.php - directory path
//** This file contains the directory path modified by Steve Perry (c) 2008
//**
//** Jumper Software
//** Version 2.0
//**Copyright: Copyright 2008 Jumper Networks Incorporated
//**Copyright: All Rights Reserved
//**Copyright:
//**Copyright: Licensed under the GNU General Public License (Version 2) published
//**Copyright: by the Free Software Foundation; you may not use this file except in
//**Copyright: compliance with the License. Permission is granted for redistribution
//**Copyright: of this file provided this copyright notice is maintained intact. If
//**Copyright: you alter or modify the contents of this file in any way from its 
//**Copyright: original form please notify Jumper Networks Incorporated.
//**Copyright: 
//**Copyright: Jumper is a trademark of Jumper Networks Incorporated
//**Copyright: which may be registered in certain jurisdictions.
//**EndComments
//**
//**********************************************************************************

// full path to jmp directory, if it does no work write it manually
$app_dir = str_replace(array('\\'), '/', getcwd() . '/');
//$app_dir = $_SERVER['DOCUMENT_ROOT'] . '/jmp/';


/* DO NOT MODIFY */
$admin_dir  = $app_dir . 'admin/';
$client_dir = $app_dir . 'client/inc/';
$cron_dir   = $app_dir . 'client/cron/';
$filename   = $app_dir . 'jmp.rss';
$category_id = (!empty($_GET['c'])) ? intval(($_GET['c'])) : false;


require_once $admin_dir . 'config.inc.php';
require_once $client_dir . 'common.inc.php';
require_once 'jumper_lib/XML/RSSCreator.php';
require_once 'jumper_lib/Util/ResultCache.php';

require_once $client_dir . 'JumperController.php';
require_once $client_dir . 'JumperRSSModel.php';
require_once $client_dir . 'DocumentParser.php';


$manager = &new JumperRSSModel();
$categories = &$manager->getCategories();
$settings = &$manager->getSettings();

if($settings['rss_generate'] == 'none') {
	exit;

} elseif($settings['rss_generate'] == 'one') {
	$category_id = false;

} elseif($settings['rss_generate'] == 'top') {
	if($category_id && (!isset($categories[$category_id]) || 
						$categories[$category_id]['parent_id'] != 0)) {
		exit;
	}
}


$controller = &new JumperController();
$controller->setDirVars($settings);
$controller->setModRewrite(false);

$channel_data = &$manager->getChannelData($category_id, $categories, $controller);
$entries = &$manager->getEntries($category_id, $categories, $controller, 15, 250);

$rss = &new RSSCreator();
$rss->setEncoding($conf['lang']['meta_charset']);
$rss->setChannel('title', $channel_data['title']);
$rss->setChannel('link', $channel_data['link']);
$rss->setChannel('description', $channel_data['description']);	

foreach($entries as $k => $v) {
	$rss->setItem($v['title'], $v['link'], $v);
}

//echo "<pre>"; print_r($filename); echo "</pre>";
//FileUtil::write($filename, $rss->getXML());

echo $rss->getXML(true);
?>